defineObject{
	name = "gen_stone_box",
	components = {
		{
			class = "Model",
			model = "mod_assets/vanblam/general/models/env/gen_stone_box.fbx",
			staticShadow = true,
		},
		{
			class = "Model",
			name = "lock",
			offset = vec(0,0,0),
			enabled = false,
		},
		{
			class = "Animation",
			animations = {
				open = "assets/animations/env/treasure_chest_open.fbx",
				close = "assets/animations/env/treasure_chest_close.fbx",
				openchest = "mod_assets/vanblam/general/animations/gen_stone_box_open.fbx",
				closechest = "mod_assets/vanblam/general/animations/gen_stone_box_close.fbx",
			},
			onAnimationEvent = function(self, event)
			if event == "open" then
			playSound ("gen_stone_slide")
			self.go.controller:open()
			elseif event == "close" then
			playSound ("gen_stone_lid_stop")
			self.go.controller:close()
				end
			end,
		},
		{
			class = "Clickable",
			offset = vec(0,0.575,0.5),
			size = vec(1.02, 1.15, 1.02),
			maxDistance = 1,
			--debugDraw = true,
		},
		{
			class = "Obstacle",
			hitSound = "barrel_hit",
		},
		{
			class = "ProjectileCollider",
		},
		{
			class = "Surface",
			offset = vec(0,0.536,0.5),
			size = vec(0.74, 0.74),
			--debugDraw = true,
		},		
		{
			class = "Chest",
		},
		{
			class = "Controller",
			onOpen = function(self)
				self.go.animation:play("openchest")
				self.go.controller:activate()
			end,
			onClose = function(self)
				self.go.animation:play("closechest")
				self.go.controller:deactivate()
			end,
		},
	},
	placement = "floor",
	editorIcon = 216,
	automapIcon = 124,
	automapIconLayer = 1,
	tags = {"vanblam" },
}

defineObject{
	name = "gen_chest_2",
	components = {
		{
			class = "Model",
			model = "mod_assets/vanblam/general/models/env/gen_chest_2.fbx",
		},
		{
			class = "Model",
			name = "lock",
			model = "mod_assets/vanblam/general/models/env/gen_chest_2_lock.fbx",
			offset = vec(0,0,0),
			enabled = false,
		},
		{
			class = "Animation",
			animations = {
				open = "assets/animations/env/treasure_chest_open.fbx",
				close = "assets/animations/env/treasure_chest_close.fbx",
				openchest = "mod_assets/vanblam/general/animations/gen_chest_2_open.fbx",
				closechest = "mod_assets/vanblam/general/animations/gen_chest_2_close.fbx",
			},
			onAnimationEvent = function(self, event)
			if event == "open" then
			playSound ("chest_open_2")
			self.go.controller:open()
			elseif event == "close" then
			playSound ("chest_close_2")
			self.go.controller:close()
				end
			end,
		},
		{
			class = "Clickable",
			offset = vec(0,0.5,0),
			size = vec(1.5, 1.0, 1.0),
			maxDistance = 1,
			--debugDraw = true,
		},
		{
			class = "Obstacle",
			hitSound = "barrel_hit",
		},
		{
			class = "ProjectileCollider",
		},
		{
			class = "Surface",
			offset = vec(0,0.153,0),
			size = vec(1.22, 0.7),
			--debugDraw = true,
		},		
		{
			class = "Chest",
		},
		{
			class = "Controller",
			onOpen = function(self)
				self.go.animation:play("openchest")
				self.go.controller:activate()
			end,
			onClose = function(self)
				self.go.animation:play("closechest")
				self.go.controller:deactivate()
			end,
		},
	},
	placement = "floor",
	editorIcon = 216,
	automapIcon = 124,
	automapIconLayer = 1,
	tags = {"vanblam" },
}

defineObject{
	name = "gen_chest_2_blue",
	components = {
		{
			class = "Model",
			model = "mod_assets/vanblam/general/models/env/gen_chest_2.fbx",
			material = "gen_chest_2_blue",
		},
		{
			class = "Model",
			name = "lock",
			model = "mod_assets/vanblam/general/models/env/gen_chest_2_lock.fbx",
			offset = vec(0,0,0),
			enabled = false,
		},
		{
			class = "Animation",
			animations = {
				open = "assets/animations/env/treasure_chest_open.fbx",
				close = "assets/animations/env/treasure_chest_close.fbx",
				openchest = "mod_assets/vanblam/general/animations/gen_chest_2_open.fbx",
				closechest = "mod_assets/vanblam/general/animations/gen_chest_2_close.fbx",
			},
			onAnimationEvent = function(self, event)
			if event == "open" then
			playSound ("chest_open_2")
			self.go.controller:open()
			elseif event == "close" then
			playSound ("chest_close_2")
			self.go.controller:close()
				end
			end,
		},
		{
			class = "Clickable",
			offset = vec(0,0.5,0),
			size = vec(1.5, 1.0, 1.0),
			maxDistance = 1,
			--debugDraw = true,
		},
		{
			class = "Obstacle",
			hitSound = "barrel_hit",
		},
		{
			class = "ProjectileCollider",
		},
		{
			class = "Surface",
			offset = vec(0,0.153,0),
			size = vec(1.22, 0.7),
			--debugDraw = true,
		},		
		{
			class = "Chest",
		},
		{
			class = "Controller",
			onOpen = function(self)
				self.go.animation:play("openchest")
				self.go.controller:activate()
			end,
			onClose = function(self)
				self.go.animation:play("closechest")
				self.go.controller:deactivate()
			end,
		},
	},
	placement = "floor",
	editorIcon = 216,
	automapIcon = 124,
	automapIconLayer = 1,
	tags = {"vanblam" },
}

defineObject{
	name = "gen_chest_2_grey",
	components = {
		{
			class = "Model",
			model = "mod_assets/vanblam/general/models/env/gen_chest_2.fbx",
			material = "gen_chest_2_grey",
		},
		{
			class = "Model",
			name = "lock",
			model = "mod_assets/vanblam/general/models/env/gen_chest_2_lock.fbx",
			offset = vec(0,0,0),
			enabled = false,
		},
		{
			class = "Animation",
			animations = {
				open = "assets/animations/env/treasure_chest_open.fbx",
				close = "assets/animations/env/treasure_chest_close.fbx",
				openchest = "mod_assets/vanblam/general/animations/gen_chest_2_open.fbx",
				closechest = "mod_assets/vanblam/general/animations/gen_chest_2_close.fbx",
			},
			onAnimationEvent = function(self, event)
			if event == "open" then
			playSound ("chest_open_2")
			self.go.controller:open()
			elseif event == "close" then
			playSound ("chest_close_2")
			self.go.controller:close()
				end
			end,
		},
		{
			class = "Clickable",
			offset = vec(0,0.5,0),
			size = vec(1.5, 1.0, 1.0),
			maxDistance = 1,
			--debugDraw = true,
		},
		{
			class = "Obstacle",
			hitSound = "barrel_hit",
		},
		{
			class = "ProjectileCollider",
		},
		{
			class = "Surface",
			offset = vec(0,0.153,0),
			size = vec(1.22, 0.7),
			--debugDraw = true,
		},		
		{
			class = "Chest",
		},
		{
			class = "Controller",
			onOpen = function(self)
				self.go.animation:play("openchest")
				self.go.controller:activate()
			end,
			onClose = function(self)
				self.go.animation:play("closechest")
				self.go.controller:deactivate()
			end,
		},
	},
	placement = "floor",
	editorIcon = 216,
	automapIcon = 124,
	automapIconLayer = 1,
	tags = {"vanblam" },
}

defineObject{
	name = "gen_chest_2_yellow",
	components = {
		{
			class = "Model",
			model = "mod_assets/vanblam/general/models/env/gen_chest_2.fbx",
			material = "gen_chest_2_yellow",
		},
		{
			class = "Model",
			name = "lock",
			model = "mod_assets/vanblam/general/models/env/gen_chest_2_lock.fbx",
			offset = vec(0,0,0),
			enabled = false,
		},
		{
			class = "Animation",
			animations = {
				open = "assets/animations/env/treasure_chest_open.fbx",
				close = "assets/animations/env/treasure_chest_close.fbx",
				openchest = "mod_assets/vanblam/general/animations/gen_chest_2_open.fbx",
				closechest = "mod_assets/vanblam/general/animations/gen_chest_2_close.fbx",
			},
			onAnimationEvent = function(self, event)
			if event == "open" then
			playSound ("chest_open_2")
			self.go.controller:open()
			elseif event == "close" then
			playSound ("chest_close_2")
			self.go.controller:close()
				end
			end,
		},
		{
			class = "Clickable",
			offset = vec(0,0.5,0),
			size = vec(1.5, 1.0, 1.0),
			maxDistance = 1,
			--debugDraw = true,
		},
		{
			class = "Obstacle",
			hitSound = "barrel_hit",
		},
		{
			class = "ProjectileCollider",
		},
		{
			class = "Surface",
			offset = vec(0,0.153,0),
			size = vec(1.22, 0.7),
			--debugDraw = true,
		},		
		{
			class = "Chest",
		},
		{
			class = "Controller",
			onOpen = function(self)
				self.go.animation:play("openchest")
				self.go.controller:activate()
			end,
			onClose = function(self)
				self.go.animation:play("closechest")
				self.go.controller:deactivate()
			end,
		},
	},
	placement = "floor",
	editorIcon = 216,
	automapIcon = 124,
	automapIconLayer = 1,
	tags = {"vanblam" },
}

defineObject{
	name = "gen_chest_2_red",
	components = {
		{
			class = "Model",
			model = "mod_assets/vanblam/general/models/env/gen_chest_2.fbx",
			material = "gen_chest_2_red",
		},
		{
			class = "Model",
			name = "lock",
			model = "mod_assets/vanblam/general/models/env/gen_chest_2_lock.fbx",
			offset = vec(0,0,0),
			enabled = false,
		},
		{
			class = "Animation",
			animations = {
				open = "assets/animations/env/treasure_chest_open.fbx",
				close = "assets/animations/env/treasure_chest_close.fbx",
				openchest = "mod_assets/vanblam/general/animations/gen_chest_2_open.fbx",
				closechest = "mod_assets/vanblam/general/animations/gen_chest_2_close.fbx",
			},
			onAnimationEvent = function(self, event)
			if event == "open" then
			playSound ("chest_open_2")
			self.go.controller:open()
			elseif event == "close" then
			playSound ("chest_close_2")
			self.go.controller:close()
				end
			end,
		},
		{
			class = "Clickable",
			offset = vec(0,0.5,0),
			size = vec(1.5, 1.0, 1.0),
			maxDistance = 1,
			--debugDraw = true,
		},
		{
			class = "Obstacle",
			hitSound = "barrel_hit",
		},
		{
			class = "ProjectileCollider",
		},
		{
			class = "Surface",
			offset = vec(0,0.153,0),
			size = vec(1.22, 0.7),
			--debugDraw = true,
		},		
		{
			class = "Chest",
		},
		{
			class = "Controller",
			onOpen = function(self)
				self.go.animation:play("openchest")
				self.go.controller:activate()
			end,
			onClose = function(self)
				self.go.animation:play("closechest")
				self.go.controller:deactivate()
			end,
		},
	},
	placement = "floor",
	editorIcon = 216,
	automapIcon = 124,
	automapIconLayer = 1,
	tags = {"vanblam" },
}

defineObject{
	name = "gen_chest_3",
	components = {
		{
			class = "Model",
			model = "mod_assets/vanblam/general/models/env/gen_chest_3.fbx",
		},
		{
			class = "Model",
			name = "lock",
			offset = vec(0,0,0),
			enabled = false,
		},
		{
			class = "Animation",
			animations = {
				open = "assets/animations/env/treasure_chest_open.fbx",
				close = "assets/animations/env/treasure_chest_close.fbx",
				openchest = "mod_assets/vanblam/general/animations/gen_chest_3_open.fbx",
				closechest = "mod_assets/vanblam/general/animations/gen_chest_3_close.fbx",
			},
			onAnimationEvent = function(self, event)
			if event == "open" then
			playSound ("chest_open_2")
			self.go.controller:open()
			elseif event == "close" then
			playSound ("chest_close_2")
			self.go.controller:close()
				end
			end,
		},
		{
			class = "Clickable",
			offset = vec(0,0.5,0.45),
			size = vec(1.5, 1.0, 1.0),
			maxDistance = 1,
			--debugDraw = true,
		},
		{
			class = "Obstacle",
			hitSound = "barrel_hit",
		},
		{
			class = "ProjectileCollider",
		},
		{
			class = "Surface",
			offset = vec(0,0.153,0.45),
			size = vec(1.20, 0.7),
			--debugDraw = true,
		},		
		{
			class = "Chest",
		},
		{
			class = "Controller",
			onOpen = function(self)
				self.go.animation:play("openchest")
				self.go.controller:activate()
			end,
			onClose = function(self)
				self.go.animation:play("closechest")
				self.go.controller:deactivate()
			end,
		},
	},
	placement = "floor",
	editorIcon = 216,
	automapIcon = 124,
	automapIconLayer = 1,
	tags = {"vanblam" },
}

defineObject{
	name = "gen_chest_3_silver",
	components = {
		{
			class = "Model",
			model = "mod_assets/vanblam/general/models/env/gen_chest_3.fbx",
			material = "gen_chest_3_silver",
		},
		{
			class = "Model",
			name = "lock",
			offset = vec(0,0,0),
			enabled = false,
		},
		{
			class = "Animation",
			animations = {
				open = "assets/animations/env/treasure_chest_open.fbx",
				close = "assets/animations/env/treasure_chest_close.fbx",
				openchest = "mod_assets/vanblam/general/animations/gen_chest_3_open.fbx",
				closechest = "mod_assets/vanblam/general/animations/gen_chest_3_close.fbx",
			},
			onAnimationEvent = function(self, event)
			if event == "open" then
			playSound ("chest_open_2")
			self.go.controller:open()
			elseif event == "close" then
			playSound ("chest_close_2")
			self.go.controller:close()
				end
			end,
		},
		{
			class = "Clickable",
			offset = vec(0,0.5,0.45),
			size = vec(1.5, 1.0, 1.0),
			maxDistance = 1,
			--debugDraw = true,
		},
		{
			class = "Obstacle",
			hitSound = "barrel_hit",
		},
		{
			class = "ProjectileCollider",
		},
		{
			class = "Surface",
			offset = vec(0,0.153,0.45),
			size = vec(1.20, 0.7),
			--debugDraw = true,
		},		
		{
			class = "Chest",
		},
		{
			class = "Controller",
			onOpen = function(self)
				self.go.animation:play("openchest")
				self.go.controller:activate()
			end,
			onClose = function(self)
				self.go.animation:play("closechest")
				self.go.controller:deactivate()
			end,
		},
	},
	placement = "floor",
	editorIcon = 216,
	automapIcon = 124,
	automapIconLayer = 1,
	tags = {"vanblam" },
}

defineObject{
	name = "gen_chest_3_gold",
	components = {
		{
			class = "Model",
			model = "mod_assets/vanblam/general/models/env/gen_chest_3.fbx",
			material = "gen_chest_3_gold",
		},
		{
			class = "Model",
			name = "lock",
			offset = vec(0,0,0),
			enabled = false,
		},
		{
			class = "Animation",
			animations = {
				open = "assets/animations/env/treasure_chest_open.fbx",
				close = "assets/animations/env/treasure_chest_close.fbx",
				openchest = "mod_assets/vanblam/general/animations/gen_chest_3_open.fbx",
				closechest = "mod_assets/vanblam/general/animations/gen_chest_3_close.fbx",
			},
			onAnimationEvent = function(self, event)
			if event == "open" then
			playSound ("chest_open_2")
			self.go.controller:open()
			elseif event == "close" then
			playSound ("chest_close_2")
			self.go.controller:close()
				end
			end,
		},
		{
			class = "Clickable",
			offset = vec(0,0.5,0.45),
			size = vec(1.5, 1.0, 1.0),
			maxDistance = 1,
			--debugDraw = true,
		},
		{
			class = "Obstacle",
			hitSound = "barrel_hit",
		},
		{
			class = "ProjectileCollider",
		},
		{
			class = "Surface",
			offset = vec(0,0.153,0.45),
			size = vec(1.20, 0.7),
			--debugDraw = true,
		},		
		{
			class = "Chest",
		},
		{
			class = "Controller",
			onOpen = function(self)
				self.go.animation:play("openchest")
				self.go.controller:activate()
			end,
			onClose = function(self)
				self.go.animation:play("closechest")
				self.go.controller:deactivate()
			end,
		},
	},
	placement = "floor",
	editorIcon = 216,
	automapIcon = 124,
	automapIconLayer = 1,
	tags = {"vanblam" },
}