defineObject{
	name = "gen_area_light_low",
	baseObject = "base_floor_decoration",
	components = {
		{
			class = "Light",
			name = "red_light",
			offset = vec(0, 2.5, 0),
			range = 12,
			color = vec(0.12, 0.15, 0.2),
			brightness = 1,
			castShadow = true,
			staticShadows = true,
			shadowMapSize = 256,
			onUpdate = function(self)
				local noise = math.noise(Time.currentTime()*3 + 123) * 0.3 + 1
				self:setBrightness(noise * 6)
			end,
		},
	},
	editorIcon = 88,
	tags = {"vanblam" },
	minimalSaveState = true,
}

defineObject{
	name = "gen_floor_torch_edge",
	baseObject = "base_wall_decoration",
	components = {
		{
			class = "Model",
			model = "mod_assets/vanblam/general/models/env/gen_floor_torch.fbx",
			staticShadow = true,
		},
		{
			class = "Light",
			offset = vec(0, 1.5, 0),
			range = 11,
			color = vec(1, 0.3, 0.08),
			brightness = 8,
			castShadow = true,
			staticShadows = true,
			shadowMapSize = 256,
			onUpdate = function(self)
				local noise = math.noise(Time.currentTime()*3 + 123) * 0.5 + 0.9
				self:setBrightness(noise * 10)
			end,
		},
		{
			class = "Particle",
			particleSystem = "gen_fire01",
			offset = vec(0, 1.25, 0),
		},
		{
			class = "Sound",
			sound = "gen_fire_small",
		},
		{
			class = "Controller",
			onActivate = function(self)
				self.go.light:enable()
				self.go.particle:enable()
			end,
			onDeactivate = function(self)
				self.go.light:disable()
				self.go.particle:disable()
			end,
			onToggle = function(self)
				if self.go.light:isEnabled() then
					self.go.light:disable()
					self.go.particle:disable()
				else
					self.go.light:enable()
					self.go.particle:enable()
				end
			end,
		},
	},
	editorIcon = 88,
	automapIcon = 92,
	tags = {"vanblam" },
}

defineObject{
	name = "gen_floor_torch_center",
	baseObject = "base_floor_decoration",
	components = {
		{
			class = "Model",
			model = "mod_assets/vanblam/general/models/env/gen_floor_torch.fbx",
			staticShadow = true,
		},
		{
			class = "Light",
			offset = vec(0, 1.5, 0),
			range = 11,
			color = vec(1, 0.3, 0.08),
			brightness = 8,
			castShadow = true,
			staticShadows = true,
			shadowMapSize = 256,
			onUpdate = function(self)
				local noise = math.noise(Time.currentTime()*3 + 123) * 0.5 + 0.9
				self:setBrightness(noise * 10)
			end,
		},
		{
			class = "Obstacle",
			hitSound = "barrel_hit",
		},
		{
			class = "Particle",
			particleSystem = "gen_fire01",
			offset = vec(0, 1.25, 0),
		},
		{
			class = "Sound",
			sound = "gen_fire_small",
		},
		{
			class = "Controller",
			onActivate = function(self)
				self.go.light:enable()
				self.go.particle:enable()
			end,
			onDeactivate = function(self)
				self.go.light:disable()
				self.go.particle:disable()
			end,
			onToggle = function(self)
				if self.go.light:isEnabled() then
					self.go.light:disable()
					self.go.particle:disable()
				else
					self.go.light:enable()
					self.go.particle:enable()
				end
			end,
		},
	},
	editorIcon = 88,
	automapIcon = 92,
	tags = {"vanblam" },
}