-- Doors --
-- Doors - Doorways --
defineObject{
	name = "rc_doorway_01",
	baseObject = "base_wall_decoration",
	components = {
		{
			class = "Model",
			model = "mod_assets/vanblam/red_cave/models/env/rc_doorway_01.fbx",
			offset = vec(0, 0, 0),
			staticShadow = true,
		},
		{
			class = "Occluder",
			model = "mod_assets/vanblam/red_cave/models/env/rc_doorway_02_occluder.fbx",
		},
	},
	minimalSaveState = true,
	tags = { "red cave", "vanblam" },
}

defineObject{
	name = "rc_doorway_01_1x3",
	baseObject = "base_wall_decoration",
	components = {
		{
			class = "Model",
			name = "hallway",
			model = "mod_assets/vanblam/red_cave/models/env/rc_doorway_01_1x3.fbx",
			offset = vec(0, 0, 0),
			staticShadow = true,
		},
		{
			class = "Occluder",
			model = "mod_assets/vanblam/red_cave/models/env/rc_doorway_01_1x3_occluder.fbx",
		},
		{
			class = "Null",
			onInit = function(self)
			local x = self.go.x
				local y = self.go.y
				local facing = self.go.facing
				local level = self.go.level
				
				local fx,fy = getForward(facing)
				local rx,ry = getForward((facing+1)%4)

				for yy=-1,2 do
					for xx=-1,1 do
						local x = x + rx * xx + fx * yy
						local y = y + ry * xx + fy * yy
						if x >= 0 and y >= 0 and x < 32 and y < 32 then
							for e in self.go.map:entitiesAt(x, y) do
								if e.name == "rc_edge_support_01"
								or e.name == "rc_edge_support_02"
								or e.name == "rc_edge_support_03"
								or e.name == "rc_edge_support_04"
								or e.name == "rc_edge_support_01b"
								or e.name == "rc_edge_support_02b"
								or e.name == "rc_edge_support_03b"
								or e.name == "rc_edge_support_04b"					
								then e:destroy()
								end
							end
						end
					end
				end
			end,
		},
	},
	minimalSaveState = true,
	tags = { "red cave", "vanblam" },
}

defineObject{
	name = "rc_doorway_02",
	baseObject = "base_wall_decoration",
	components = {
		{
			class = "Model",
			model = "mod_assets/vanblam/red_cave/models/env/rc_doorway_02.fbx",
			offset = vec(0, 0, 0),
			staticShadow = true,
		},
		{
			class = "Occluder",
			model = "mod_assets/vanblam/red_cave/models/env/rc_doorway_02_occluder.fbx",
		},
	},
	minimalSaveState = true,
	tags = { "red cave", "vanblam" },
}

defineObject{
	name = "rc_stone_door_01",
	baseObject = "base_wall_decoration",
	components = {
		{
			class = "Model",
			model = "mod_assets/vanblam/red_cave/models/env/rc_stone_door_01.fbx",
			staticShadow = true,
		},
		{
			class = "Controller",
			onOpen = function(self)
				self.go.door:open()
			end,
			onClose = function(self)
				self.go.door:close()
			end,
			onToggle = function(self)
				self.go.door:toggle()
			end,
		},
		{
			class = "Door",
			openVelocity = 0.75,
			closeVelocity = 0.75,
			closeAcceleration = -3,
			openingDirection = "up",
			maxHeight = 2.4,
			openSound = "gen_stone_door_move",
			closeSound = "gen_stone_door_move",
			lockSound = "gen_stone_door_end",
			--sparse = true,
			killPillars = false,
		},
		{
			class = "ItemConstrainBox",
			name = "cbox1",
			size = vec(0.7, 3, 0.7),
			offset = vec(-1.5, 1.5, 0),
			--debugDraw = true,
		},
		{
			class = "ItemConstrainBox",
			name = "cbox2",
			size = vec(0.7, 3, 0.7),
			offset = vec(1.5, 1.5, 0),
			--debugDraw = true,
		},
	},
	editorIcon = 124,
	automapIcon = 84,
	tags = { "red cave", "vanblam", "door"},
}

defineObject{
	name = "rc_stone_door_02",
	baseObject = "base_wall_decoration",
	components = {
		{
			class = "Model",
			model = "mod_assets/vanblam/red_cave/models/env/rc_stone_door_02.fbx",
			staticShadow = true,
		},
		{
			class = "Controller",
			onOpen = function(self)
				self.go.door:open()
			end,
			onClose = function(self)
				self.go.door:close()
			end,
			onToggle = function(self)
				self.go.door:toggle()
			end,
		},
		{
			class = "Door",
			openVelocity = 0.75,
			closeVelocity = 0.75,
			closeAcceleration = -3,
			openingDirection = "down",
			maxHeight = 2.65,
			openSound = "gen_stone_door_move",
			closeSound = "gen_stone_door_move",
			lockSound = "gen_stone_door_end",
			--sparse = true,
			killPillars = false,
		},
		{
			class = "ItemConstrainBox",
			name = "cbox1",
			size = vec(0.7, 3, 0.7),
			offset = vec(-1.5, 1.5, 0),
			--debugDraw = true,
		},
		{
			class = "ItemConstrainBox",
			name = "cbox2",
			size = vec(0.7, 3, 0.7),
			offset = vec(1.5, 1.5, 0),
			--debugDraw = true,
		},
		{
			class = "Model",
			name = "frame",
			model = "mod_assets/vanblam/red_cave/models/env/rc_stone_door_02_frame.fbx",
			staticShadow = true,
		},
	},
	editorIcon = 124,
	automapIcon = 84,
	tags = { "red cave", "vanblam", "door"},
}

defineObject{
	name = "rc_portcullis_gate_doors",
	components = {
		{
			class = "Model",
			model = "mod_assets/vanblam/red_cave/models/env/rc_portcullis_gate_doors.fbx",
			staticShadow = true,
		},
		{
			class = "Controller",
			onOpen = function(self)
				self.go.door:open()
			end,
			onClose = function(self)
				self.go.door:close()
			end,
			onToggle = function(self)
				self.go.door:toggle()
			end,
		},
		{
			class = "Door",
			doubleDoor = true,
			killPillars = false,
			openVelocity = 3,
			closeVelocity = -2.5,
			closeAcceleration = 0,
			maxHeight = 1.1,
			openSound = "spear_door",
			closeSound = "spear_door",
		},
		{
			class = "Model",
			name = "frame",
			model = "mod_assets/vanblam/red_cave/models/env/rc_portcullis_gate_doors_frame.fbx",
			staticShadow = true,
		},
	},
	placement = "wall",
	editorIcon = 124,
	automapIcon = 84,
	tags = { "red cave", "vanblam", "door"},
}

defineObject{
	name = "rc_portcullis_door_2",
	components = {
		{
			class = "Model",
			model = "mod_assets/vanblam/red_cave/models/env/rc_portcullis_door_2.fbx",
			staticShadow = true,
		},
		{
			class = "Controller",
			onOpen = function(self)
				self.go.door:open()
			end,
			onClose = function(self)
				self.go.door:close()
			end,
			onToggle = function(self)
				self.go.door:toggle()
			end,
		},
		{
			class = "Door",
			openVelocity = 2,
			closeVelocity = 0.5,
			closeAcceleration = -6,
			openingDirection = "down",
			maxHeight = 3,
			killPillars = false,
		},
		{
			class = "Model",
			name = "frame",
			model = "mod_assets/vanblam/red_cave/models/env/rc_portcullis_door_2_frame.fbx",
			staticShadow = true,
		},
		{
			class = "Null",
			name = "auto_destroy_objects",
			onInit = function(self)
				local x = self.go.x
				local y = self.go.y
				local facing = self.go.facing
				local level = self.go.level
				local fx,fy = getForward(facing)
				local rx,ry = getForward((facing+1)%4)

				for yy=0,1 do
					for xx=0,0 do
						local x = x + rx * xx + fx * yy
						local y = y + ry * xx + fy * yy
						if x >= 0 and y >= 0 and x < 32 and y < 32 then
							for e in self.go.map:entitiesAt(x, y) do
								if e.name == "rc_ground_tiles_01"	
								or e.name == "rc_ground_tiles_02" 
								or e.name == "rc_ground_tiles_03"
								or e.name == "rc_ground_tiles_04"
								or e.name == "rc_ground_tiles_05"
								or e.name == "rc_ground_tiles_06"
								or e.name == "rc_ground_tiles_07"
						    	then
								e:destroy()
								end
							end
						end
					end
				end
			end
		},
	},
	placement = "wall",
	editorIcon = 124,
	automapIcon = 84,
	tags = { "red cave", "vanblam", "door"},
}

defineObject{
	name = "rc_the_door",
	baseObject = "base_wall_decoration",
	components = {
		{
			class = "Model",
			model = "mod_assets/vanblam/red_cave/models/env/rc_the_door.fbx",
			staticShadow = true,
		},
		{
			class = "Model",
			name = "frame",
			model = "mod_assets/vanblam/red_cave/models/env/rc_the_door_frame.fbx",
			staticShadow = true,
		},
		{
			class = "Null",
			onInit = function(self)
			local x = self.go.x
				local y = self.go.y
				local facing = self.go.facing
				local level = self.go.level
				
				local fx,fy = getForward(facing)
				local rx,ry = getForward((facing+1)%4)

				for yy=0,0 do
					for xx=-2,2 do
						local x = x + rx * xx + fx * yy
						local y = y + ry * xx + fy * yy
						if x >= 0 and y >= 0 and x < 32 and y < 32 then
							for e in self.go.map:entitiesAt(x, y) do
								if e.name == "rc_edge_support_01"
								or e.name == "rc_edge_support_02"
								or e.name == "rc_edge_support_03"
								or e.name == "rc_edge_support_04"
								or e.name == "rc_edge_support_01b"
								or e.name == "rc_edge_support_02b"
								or e.name == "rc_edge_support_03b"
								or e.name == "rc_edge_support_04b"					
								then e:destroy()
								end
							end
						end
					end
				end
			end,
		},
		{
			class = "Controller",
			onOpen = function(self)
				self.go.door:open()
			end,
			onClose = function(self)
				self.go.door:close()
			end,
			onToggle = function(self)
				self.go.door:toggle()
			end,
		},
		{
			class = "Door",
			openVelocity = 1.2,
			closeVelocity = 0.75,
			closeAcceleration = -3,
			openingDirection = "up",
			maxHeight = 3.4,
			openSound = "rc_big_door_move",
			closeSound = "rc_big_door_move",
			lockSound = "rc_big_door_stop",
			--sparse = true,
			killPillars = false,
		},
		{
			class = "ItemConstrainBox",
			name = "cbox1",
			size = vec(3, 4.5,3),
			offset = vec(-4.15, 2.25, 0),
			--debugDraw = true,
		},
		{
			class = "ItemConstrainBox",
			name = "cbox2",
			size = vec(3,4.5, 3),
			offset = vec(4.15, 2.25, 0),
			--debugDraw = true,
		},
	},
	editorIcon = 124,
	automapIcon = 84,
	tags = { "red cave", "vanblam", "door"},
}

defineObject{
	name = "rc_the_door_down",
	baseObject = "base_wall_decoration",
	components = {
		{
			class = "Model",
			model = "mod_assets/vanblam/red_cave/models/env/rc_the_door_down.fbx",
			staticShadow = true,
		},
		{
			class = "Model",
			name = "frame",
			model = "mod_assets/vanblam/red_cave/models/env/rc_the_door_frame_down.fbx",
			staticShadow = true,
		},
		{
			class = "Null",
			onInit = function(self)
			local x = self.go.x
				local y = self.go.y
				local facing = self.go.facing
				local level = self.go.level
				
				local fx,fy = getForward(facing)
				local rx,ry = getForward((facing+1)%4)
				
				for yy=0,0 do
					for xx=-2,2 do
						local x = x + rx * xx + fx * yy
						local y = y + ry * xx + fy * yy
						if x >= 0 and y >= 0 and x < 32 and y < 32 then
							for e in self.go.map:entitiesAt(x, y) do
								if e.name == "rc_edge_support_01"
								or e.name == "rc_edge_support_02"
								or e.name == "rc_edge_support_03"
								or e.name == "rc_edge_support_04"
								or e.name == "rc_edge_support_01b"
								or e.name == "rc_edge_support_02b"
								or e.name == "rc_edge_support_03b"
								or e.name == "rc_edge_support_04b"					
								then e:destroy()
								end
							end
						end
					end
				end
			end,
		},
		{
			class = "Controller",
			onOpen = function(self)
				self.go.door:open()
			end,
			onClose = function(self)
				self.go.door:close()
			end,
			onToggle = function(self)
				self.go.door:toggle()
			end,
		},
		{
			class = "Door",
			openVelocity = 1.5,
			closeVelocity = 0.75,
			closeAcceleration = -3,
			openingDirection = "down",
			maxHeight = 4.3,
			openSound = "rc_big_door_move",
			closeSound = "rc_big_door_move",
			lockSound = "rc_big_door_stop",
			--sparse = true,
			killPillars = false,
		},
		{
			class = "ItemConstrainBox",
			name = "cbox1",
			size = vec(3, 4.5,3),
			offset = vec(-4.15, 2.25, 0),
			--debugDraw = true,
		},
		{
			class = "ItemConstrainBox",
			name = "cbox2",
			size = vec(3,4.5, 3),
			offset = vec(4.15, 2.25, 0),
			--debugDraw = true,
		},
	},
	editorIcon = 124,
	automapIcon = 84,
	tags = { "red cave", "vanblam", "door"},
}

defineObject{
	name = "rc_secret_wall_01",
	baseObject = "base_wall_decoration",
	components = {
		{
			class = "Model",
			model = "mod_assets/vanblam/red_cave/models/env/rc_secret_wall_01.fbx",
			staticShadow = true,
		},
		{
			class = "Controller",
			onOpen = function(self)
				self.go.door:open()
			end,
			onClose = function(self)
				self.go.door:close()
			end,
			onToggle = function(self)
				self.go.door:toggle()
			end,
		},
		{
			class = "Door",
			openVelocity = 0.4,
			closeVelocity = 0.1,
			closeAcceleration = -3,
			openingDirection = "up",
			maxHeight = 3.4,
			openSound = "gen_stone_door_move",
			closeSound = "gen_stone_door_move",
			lockSound = "gen_stone_door_end",
			--sparse = true,
			killPillars = false,
		},
	},
	editorIcon = 124,
	automapTile = "rocky_wall",
	tags = { "red cave", "vanblam", "door"},
}