-- Framework --
-- Walls - Floors - Celings --

defineObject{
	name = "rc_ground_01",
	baseObject = "base_floor",
	components = {
		{
			class = "Null",
			onInit = function(self)
				-- autoDecoFloor01 stuff
				local g = self.go
				local choice = math.random()
				if choice >= 0.6 then
					  spawn("rc_grass_01a",g.level,g.x,g.y,math.random(0,3),g.elevation)
					elseif choice >= 0.4 then
					  spawn("rc_grass_01b",g.level,g.x,g.y,math.random(0,3),g.elevation)
					elseif choice >= 0.2 then
					  spawn("rc_grass_01c",g.level,g.x,g.y,math.random(0,3),g.elevation)
				end
				choice = math.random()
				if choice >= 0.94 then
					  spawn("rc_ground_tiles_01",g.level,g.x,g.y,math.random(0,3),g.elevation)
					elseif choice >= 0.88 then
					  spawn("rc_ground_tiles_02",g.level,g.x,g.y,math.random(0,3),g.elevation)
					elseif choice >= 0.82 then
					  spawn("rc_ground_tiles_03",g.level,g.x,g.y,math.random(0,3),g.elevation)
					elseif choice >= 0.76 then
					  spawn("rc_ground_tiles_04",g.level,g.x,g.y,math.random(0,3),g.elevation)
					elseif choice >= 0.7 then
					  spawn("rc_ground_tiles_05",g.level,g.x,g.y,math.random(0,3),g.elevation)
				end
				choice = math.random()
				if choice >= 0.8 then
					  spawn("rc_ground_pebbles_04",g.level,g.x,g.y,math.random(0,3),g.elevation)
					elseif choice >= 0.6 then
					  spawn("rc_ground_pebbles_01",g.level,g.x,g.y,math.random(0,3),g.elevation)
					elseif choice >= 0.4 then
					  spawn("rc_ground_pebbles_02",g.level,g.x,g.y,math.random(0,3),g.elevation)
					elseif choice >= 0.2 then
					  spawn("rc_ground_pebbles_03",g.level,g.x,g.y,math.random(0,3),g.elevation)
				end

				-- spawn floor object, which destroys this object due to replacesFloor
				g:spawn("rc_ground_01_real")
			end,
		},
	},
	replacesFloor = true,
	tags = { "red cave", "vanblam" },
}

defineObject{
	name = "rc_ground_01_real",
	placement = "floor",
	components = {
		{
			class = "Model",
			model = "mod_assets/vanblam/red_cave/models/env/rc_ground_01.fbx",
			staticShadow = true,
			offset = vec(0, -0.05, 0),
		},
		{
			class = "Occluder",
			model = "assets/models/env/dungeon_floor_01_occluder.fbx",
		},
	},
	replacesFloor = true,
	minimalSaveState = true,
}

defineObject{
	name = "rc_ground_02",
	baseObject = "base_floor",
	components = {
		{
			class = "Null",
			onInit = function(self)
				-- autoDecoFloor02 stuff
				local g = self.go
				local choice = math.random()
				if choice >= 0.6 then
					  spawn("rc_grass_01a",g.level,g.x,g.y,math.random(0,3),g.elevation)
					elseif choice >= 0.4 then
					  spawn("rc_grass_01b",g.level,g.x,g.y,math.random(0,3),g.elevation)
					elseif choice >= 0.2 then
					  spawn("rc_grass_01c",g.level,g.x,g.y,math.random(0,3),g.elevation)
				end
				local choice = math.random()
				if choice >= 0.75 then
					  spawn("rc_ground_tiles_06",g.level,g.x,g.y,math.random(0,3),g.elevation)
					elseif choice >= 0.37 then
					  spawn("rc_ground_tiles_07",g.level,g.x,g.y,math.random(0,3),g.elevation)
				end
				local choice = math.random()
				if choice >= 0.8 then
					  spawn("rc_ground_pebbles_04",g.level,g.x,g.y,math.random(0,3),g.elevation)
					elseif choice >= 0.6 then
					  spawn("rc_ground_pebbles_01",g.level,g.x,g.y,math.random(0,3),g.elevation)
					elseif choice >= 0.4 then
					  spawn("rc_ground_pebbles_02",g.level,g.x,g.y,math.random(0,3),g.elevation)
					elseif choice >= 0.2 then
					  spawn("rc_ground_pebbles_03",g.level,g.x,g.y,math.random(0,3),g.elevation)
				end

				-- spawn floor object, which destroys this object due to replacesFloor
				g:spawn("rc_ground_02_real")
			end,
		},
	},
	replacesFloor = true,
	tags = { "red cave", "vanblam" },
}

defineObject{
	name = "rc_ground_02_real",
	placement = "floor",
	components = {
		{
			class = "Model",
			model = "mod_assets/vanblam/red_cave/models/env/rc_ground_02.fbx",
			staticShadow = true,
			--offset = vec(0, -0.05, 0),
		},
		{
			class = "Occluder",
			model = "assets/models/env/dungeon_floor_01_occluder.fbx",
		},
	},
	replacesFloor = true,
	minimalSaveState = true,
}

defineObject{
	name = "rc_molten_floor_01",
	baseObject = "base_floor_decoration",
	components = {
		{
			class = "Model",
			model = "mod_assets/vanblam/red_cave/models/env/rc_molten_floor_01.fbx",
			staticShadow = true,
			offset = vec(0, -0.05, 0),
		},
		{
			class = "Light",
			range = 3,
			offset = vec(0, 3.2, 0),
			color = vec(1, 0.13, 0),
			brightness = 80,
			castShadow = false,
			staticShadows = true,
			shadowMapSize = 256,
		},
		{
			class = "Light",
			name = "dim_light",
			range = 10,
			offset = vec(0, 3.2, 0),
			color = vec(1, 0.12, 0),
			brightness = 2.5,
			castShadow = false,
			staticShadows = true,
			shadowMapSize = 256,
			-- onUpdate = function(self)
				-- local noise = math.noise(Time.currentTime()*3 + 114) * 0.5 + 0.9
				-- self:setBrightness(noise * 20)
			-- end,
		},
		{
			class = "Particle",
			particleSystem = "gen_lava_smoke01",
			emitterMesh = "mod_assets/vanblam/red_cave/models/env/rc_lava_e_mesh.fbx",
		},
		{
			class = "Particle",
			name = "glow",
			particleSystem = "gen_lava_glow",
			emitterMesh = "mod_assets/vanblam/red_cave/models/env/rc_lava_e_mesh.fbx",
		},
		{
			class = "Particle",
			name = "sparks",
			particleSystem = "gen_lava_sparks01",
			emitterMesh = "mod_assets/vanblam/red_cave/models/env/rc_lava_e_mesh_sparks.fbx",
		},
		{
			class = "Particle",
			name = "splashes",
			particleSystem = "rc_lava_splash",
		},
		{
     			class = "Timer",
      			name = "splashestimer",
      			timerInterval = 0.5,
      			onActivate = function(self)
        			local time = math.random(3,10)
        			self.go.splashestimer:setTimerInterval(time)
        			self.go.splashes:restart()
					self.go.splashsound:play("gen_lava_splash")
      			end,
		},
		{
     			class = "Timer",
      			name = "sparkstimer",
      			timerInterval = 0.5,
      			onActivate = function(self)
        			local time = math.random(5,20)
        			self.go.sparkstimer:setTimerInterval(time)
        			self.go.sparks:restart()
      			end,
		},
		{
			class = "Sound",
			sound = "gen_lava",
		},
		{
			class = "Sound",
			name = "splashsound",
			sound = "gen_lava_splash",
		},
		{
			class = "Occluder",
			model = "assets/models/env/dungeon_floor_01_occluder.fbx",
		},
	},
	minimalSaveState = true,
	tags = { "red cave", "vanblam" },
}

defineObject{
	name = "rc_molten_floor_01_void",
	baseObject = "base_floor_decoration",
	components = {
		{
			class = "Light",
			range = 3,
			offset = vec(0, 3.2, 0),
			color = vec(1, 0.13, 0),
			brightness = 80,
			castShadow = false,
			staticShadows = true,
			shadowMapSize = 256,
		},
		{
			class = "Light",
			name = "dim_light",
			range = 10,
			offset = vec(0, 3.2, 0),
			color = vec(1, 0.12, 0),
			brightness = 2.5,
			castShadow = false,
			staticShadows = true,
			shadowMapSize = 256,
			-- onUpdate = function(self)
				-- local noise = math.noise(Time.currentTime()*3 + 114) * 0.5 + 0.9
				-- self:setBrightness(noise * 20)
			-- end,
		},
		{
			class = "Particle",
			particleSystem = "gen_lava_smoke01",
			emitterMesh = "mod_assets/vanblam/red_cave/models/env/rc_lava_e_mesh.fbx",
		},
		{
			class = "Particle",
			name = "glow",
			particleSystem = "gen_lava_glow",
			emitterMesh = "mod_assets/vanblam/red_cave/models/env/rc_lava_e_mesh.fbx",
		},
		{
			class = "Particle",
			name = "sparks",
			particleSystem = "gen_lava_sparks01",
			emitterMesh = "mod_assets/vanblam/red_cave/models/env/rc_lava_e_mesh_sparks.fbx",
		},
		{
			class = "Particle",
			name = "splashes",
			particleSystem = "rc_lava_splash",
		},
		{
     			class = "Timer",
      			name = "splashestimer",
      			timerInterval = 0.5,
      			onActivate = function(self)
        			local time = math.random(3,10)
        			self.go.splashestimer:setTimerInterval(time)
        			self.go.splashes:restart()
					self.go.splashsound:play("gen_lava_splash")
      			end,
		},
		{
     			class = "Timer",
      			name = "sparkstimer",
      			timerInterval = 0.5,
      			onActivate = function(self)
        			local time = math.random(5,20)
        			self.go.sparkstimer:setTimerInterval(time)
        			self.go.sparks:restart()
      			end,
		},
		{
			class = "Sound",
			sound = "gen_lava",
		},
		{
			class = "Sound",
			name = "splashsound",
			sound = "gen_lava_splash",
		},
	},
	minimalSaveState = true,
	tags = { "red cave", "vanblam" },
}

defineObject{
	name = "rc_wall_01a",
	baseObject = "base_wall_decoration",
	components = {
		{
			class = "Model",
			model = "mod_assets/vanblam/red_cave/models/env/rc_wall_01a.fbx",
			staticShadow = true,
		},
		{
			class = "Light",
			name = "crystal_light_01w1a",
			offset = vec(-0.6, 2.7, -0.01),
			range = 2.5,
			color = vec(0.75, 0.05, 0),
			brightness = 2,
			castShadow = false,
			fillLight = true,
		},
		{
			class = "Light",
			name = "crystal_light_02w1a",
			offset = vec(0.56, 1.71, -0.13),
			range = 2.5,
			color = vec(0.75, 0.05, 0),
			brightness = 2,
			castShadow = false,
			fillLight = true,
		},
		{
				class = "Particle",
				particleSystem = "rc_crystal_small",
				emitterMesh = "mod_assets/vanblam/red_cave/models/env/rc_wall_01a_crystal_mesh.fbx",
		},
		{
			class = "Occluder",
			model = "assets/models/env/mine_wall_01_occluder.fbx",
		},
	},
	editorIcon = 92,
	minimalSaveState = true,
	tags = { "red cave", "vanblam" },
}

defineObject{
	name = "rc_wall_01b",
	baseObject = "base_wall_decoration",
	components = {
		{
			class = "Model",
			model = "mod_assets/vanblam/red_cave/models/env/rc_wall_01b.fbx",
			staticShadow = true,
		},
		{
			class = "Light",
			name = "crystal_light_01w1b",
			offset = vec(-0.56, 2.25, 0.43),
			range = 2.5,
			color = vec(0.75, 0.05, 0),
			brightness = 2,
			castShadow = false,
			fillLight = true,
		},
		{
			class = "Light",
			name = "crystal_light_02w1b",
			offset = vec(0.57, 1.73, 0.23),
			range = 2.5,
			color = vec(0.75, 0.05, 0),
			brightness = 2,
			castShadow = false,
			fillLight = true,
		},
		{
				class = "Particle",
				particleSystem = "rc_crystal_small",
				emitterMesh = "mod_assets/vanblam/red_cave/models/env/rc_wall_01b_crystal_mesh.fbx",
		},
		{
			class = "Occluder",
			model = "assets/models/env/mine_wall_01_occluder.fbx",
		},
	},
	editorIcon = 92,
	minimalSaveState = true,
	tags = { "red cave", "vanblam" },
}

defineObject{
	name = "rc_wall_01c",
	baseObject = "base_wall_decoration",
	components = {
		{
			class = "Model",
			model = "mod_assets/vanblam/red_cave/models/env/rc_wall_01c.fbx",
			staticShadow = true,
		},
		{
			class = "Occluder",
			model = "assets/models/env/mine_wall_01_occluder.fbx",
		},
	},
	editorIcon = 92,
	minimalSaveState = true,
	tags = { "red cave", "vanblam" },
}

defineObject{
	name = "rc_wall_02a",
	baseObject = "base_wall_decoration",
	components = {
		{
			class = "Model",
			model = "mod_assets/vanblam/red_cave/models/env/rc_wall_02a.fbx",
			staticShadow = true,
		},
		{
			class = "Occluder",
			model = "assets/models/env/mine_wall_01_occluder.fbx",
		},
	},
	editorIcon = 92,
	minimalSaveState = true,
	tags = { "red cave", "vanblam" },
}

defineObject{
	name = "rc_wall_02a_standard",
	baseObject = "base_wall_decoration",
	components = {
		{
			class = "Model",
			model = "mod_assets/vanblam/red_cave/models/env/rc_wall_02a.fbx",
			rotation = vec (0,90,0),
			staticShadow = true,
		},
		{
			class = "Occluder",
			model = "assets/models/env/mine_wall_01_occluder.fbx",
			rotation = vec (0,90,0),
		},
	},
	minimalSaveState = true,
	tags = { "red cave", "vanblam" },
}

defineObject{
	name = "rc_wall_02b",
	baseObject = "base_wall_decoration",
	components = {
		{
			class = "Model",
			model = "mod_assets/vanblam/red_cave/models/env/rc_wall_02b.fbx",
			staticShadow = true,
		},
		{
			class = "Occluder",
			model = "assets/models/env/mine_wall_01_occluder.fbx",
		},
	},
	editorIcon = 92,
	minimalSaveState = true,
	tags = { "red cave", "vanblam" },
}

defineObject{
	name = "rc_wall_02b_standard",
	baseObject = "base_wall_decoration",
	components = {
		{
			class = "Model",
			model = "mod_assets/vanblam/red_cave/models/env/rc_wall_02b.fbx",
			rotation = vec (0,90,0),
			staticShadow = true,
		},
		{
			class = "Occluder",
			model = "assets/models/env/mine_wall_01_occluder.fbx",
			rotation = vec (0,90,0),
		},
	},
	minimalSaveState = true,
	tags = { "red cave", "vanblam" },
}

defineObject{
	name = "rc_molten_edge_01",
	components = {
		{
			class = "Model",
			model = "mod_assets/vanblam/red_cave/models/env/rc_molten_edge_01.fbx",
			staticShadow = true,
		},
		{
			class = "Door",
			sparse = true,
			hitSound = "impact_blunt",
		},
	},
	placement = "wall",
	editorIcon = 160,
	automapIcon = 88,
	minimalSaveState = true,
	tags = { "red cave", "vanblam" },
}

defineObject{
	name = "rc_molten_edge_02",
	components = {
		{
			class = "Model",
			model = "mod_assets/vanblam/red_cave/models/env/rc_molten_edge_02.fbx",
			staticShadow = true,
		},
		{
			class = "Door",
			sparse = true,
			hitSound = "impact_blunt",
		},
	},
	placement = "wall",
	editorIcon = 160,
	automapIcon = 88,
	minimalSaveState = true,
	tags = { "red cave", "vanblam" },
}

defineObject{
	name = "rc_molten_pillar_01",
	baseObject = "base_pillar",
	components = {
		{
			class = "Model",
			model = "mod_assets/vanblam/red_cave/models/env/rc_molten_pillar_01.fbx",
			staticShadow = true,
		},
	},
	minimalSaveState = true,
	tags = { "red cave", "vanblam" },
}

defineObject{
	name = "rc_elevation_edge_01",
	components = {
		{
			class = "Model",
			model = "mod_assets/vanblam/red_cave/models/env/rc_elevation_edge_01.fbx",
			staticShadow = true,
		},
		{
			class = "Door",
			sparse = true,
			hitSound = "impact_blunt",
		},
		{
			class = "Null",
			onInit = function(self)
			local g = self.go
			do
				spawn("rc_elevation_empty", g.level, g.x, g.y,g.facing,g.elevation -1)
			end
					if g.map:getElevation(g.x,g.y) == g.elevation then
						local choice = math.random()
						if choice >= 0.66 then
							g:spawn("rc_rocks_trim_01")
						elseif choice >= 0.33 then
							g:spawn("rc_rocks_trim_02")
						else
							g:spawn("rc_rocks_trim_03")
						end
					end
			end
		},
	},
	placement = "wall",
	editorIcon = 160,
	tags = { "red cave", "vanblam" },
}

defineObject{
	name = "rc_elevation_edge_02",
	components = {
		{
			class = "Model",
			model = "mod_assets/vanblam/red_cave/models/env/rc_elevation_edge_02.fbx",
			staticShadow = true,
		},
		{
			class = "Door",
			sparse = true,
			hitSound = "impact_blunt",
		},
		{
			class = "Null",
			onInit = function(self)
			local g = self.go
			do
				spawn("rc_elevation_empty", g.level, g.x, g.y,g.facing,g.elevation -1)
			end
					if g.map:getElevation(g.x,g.y) == g.elevation then
						local choice = math.random()
						if choice >= 0.8 then
							g:spawn("rc_rocks_trim_01")
							elseif choice >= 0.6 then
							g:spawn("rc_rocks_trim_02")
							elseif choice >= 0.4 then
							g:spawn("rc_rocks_trim_03")
							else
							g:spawn("rc_elevation_slope",g.level,g.x,g.y,math.random(0,3),g.elevation)
						end
					end
			end	
		},
	},
	placement = "wall",
	editorIcon = 160,
	tags = { "red cave", "vanblam" },
}

defineObject{
	name = "rc_elevation_empty",
	components = {
		{
			class = "Null",
			onInit = function(self)
			self.go:destroy()
			end
		},
	},
	placement = "wall",
	replacesWall = true,
}

defineObject{
	name = "rc_elevation_slope",
	components = {
		{
			class = "Model",
			model = "mod_assets/vanblam/red_cave/models/env/rc_elevation_slope.fbx",
			staticShadow = true,
			offset = vec(0, -0.06, 0),
		},
	},
	minimalSaveState = true,
	placement = "wall",
	editorIcon = 236,
	tags = { "red cave", "vanblam" },
}

defineObject{
	name = "rc_ceiling_01a",
	baseObject = "base_ceiling",
	components = {
		{
			class = "Model",
			model = "mod_assets/vanblam/red_cave/models/env/rc_ceiling_01a.fbx",
			staticShadow = true,
		},
		{
			class = "Light",
			offset = vec(0.60, 3.77, 0.12),
			range = 2.5,
			color = vec(0.75, 0.05, 0),
			brightness = 2,
			castShadow = false,
			fillLight = true,
		},
		{
				class = "Particle",
				particleSystem = "rc_crystal_small",
				emitterMesh = "mod_assets/vanblam/red_cave/models/env/rc_ceiling_01a_crystal_mesh.fbx",
		},
		{
			class = "Occluder",
			model = "assets/models/env/mine_ceiling_01_occluder.fbx",
		},
	},
	minimalSaveState = true,
	editorIcon = 136,
	tags = { "red cave", "vanblam" },
}

defineObject{
	name = "rc_ceiling_01b",
	baseObject = "base_ceiling",
	components = {
		{
			class = "Model",
			model = "mod_assets/vanblam/red_cave/models/env/rc_ceiling_01b.fbx",
			staticShadow = true,
		},
		{
			class = "Occluder",
			model = "assets/models/env/mine_ceiling_01_occluder.fbx",
		},
	},
	minimalSaveState = true,
	editorIcon = 136,
	tags = { "red cave", "vanblam" },
}

defineObject{
	name = "rc_ceiling_01c",
	baseObject = "base_ceiling",
	components = {
		{
			class = "Model",
			model = "mod_assets/vanblam/red_cave/models/env/rc_ceiling_01c.fbx",
			staticShadow = true,
		},
		{
			class = "Light",
			name = "crystal_light_01c1c",
			offset = vec(-0.88, 3.72, 0.55),
			range = 2.5,
			color = vec(0.75, 0.05, 0),
			brightness = 2,
			castShadow = false,
			fillLight = true,
		},
		{
			class = "Light",
			name = "crystal_light_02c1c",
			offset = vec(0.15, 3.7, -1.22),
			range = 2.5,
			color = vec(0.75, 0.05, 0),
			brightness = 2,
			castShadow = false,
			fillLight = true,
		},
		{
				class = "Particle",
				particleSystem = "rc_crystal_small",
				emitterMesh = "mod_assets/vanblam/red_cave/models/env/rc_ceiling_01c_crystal_mesh.fbx",
		},
		{
			class = "Occluder",
			model = "assets/models/env/mine_ceiling_01_occluder.fbx",
		},
	},
	minimalSaveState = true,
	editorIcon = 136,
	tags = { "red cave", "vanblam" },
}

defineObject{
	name = "rc_ceiling_01d",
	baseObject = "base_ceiling",
	components = {
		{
			class = "Model",
			model = "mod_assets/vanblam/red_cave/models/env/rc_ceiling_01d.fbx",
			staticShadow = true,
		},
		{
			class = "Occluder",
			model = "assets/models/env/mine_ceiling_01_occluder.fbx",
		},
	},
	minimalSaveState = true,
	editorIcon = 136,
	tags = { "red cave", "vanblam" },
}

defineObject{
	name = "rc_ceiling_01e",
	baseObject = "base_ceiling",
	components = {
		{
			class = "Model",
			model = "mod_assets/vanblam/red_cave/models/env/rc_ceiling_01e.fbx",
			staticShadow = true,
		},
		{
			class = "Light",
			offset = vec(-1.45, 3.6, 0.67),
			range = 2.5,
			color = vec(0.75, 0.05, 0),
			brightness = 2,
			castShadow = false,
			fillLight = true,
		},
		{
				class = "Particle",
				particleSystem = "rc_crystal_small",
				emitterMesh = "mod_assets/vanblam/red_cave/models/env/rc_ceiling_01e_crystal_mesh.fbx",
		},
		{
			class = "Occluder",
			model = "assets/models/env/mine_ceiling_01_occluder.fbx",
		},
	},
	minimalSaveState = true,
	editorIcon = 136,
	tags = { "red cave", "vanblam" },
}
defineObject{
	name = "rc_ceiling_02",
	baseObject = "base_ceiling",
	components = {
		{
			class = "Model",
			model = "mod_assets/vanblam/red_cave/models/env/rc_ceiling_02.fbx",
			staticShadow = true,
		},
		{
			class = "Occluder",
			model = "assets/models/env/mine_ceiling_01_occluder.fbx",
		},
	},
	minimalSaveState = true,
	editorIcon = 136,
	tags = { "red cave", "vanblam" },
}

defineObject{
	name = "rc_pillar_01a",
	baseObject = "base_floor_decoration",
	components = {
		{
			class = "Model",
			model = "mod_assets/vanblam/red_cave/models/env/rc_pillar_01a.fbx",
			staticShadow = true,
		},
		{
			class = "Light",
			name = "crystal_light_01p1a",
			offset = vec(-0.61, 0.9, -1.2),
			range = 2.5,
			color = vec(0.75, 0.05, 0),
			brightness = 2,
			castShadow = false,
			fillLight = true,
		},
		{
			class = "Light",
			name = "crystal_light_02p1a",
			offset = vec(-0.38, 3.09, -1.37),
			range = 2.5,
			color = vec(0.75, 0.05, 0),
			brightness = 2,
			castShadow = false,
			fillLight = true,
		},
		{
			class = "Light",
			name = "crystal_light_03p1a",
			offset = vec(-1.3, 1.24, 0.4),
			range = 2.5,
			color = vec(0.75, 0.05, 0),
			brightness = 2,
			castShadow = false,
			fillLight = true,
		},
		{
			class = "Light",
			name = "crystal_light_04p1a",
			offset = vec(0.23, 1.15, 1.26),
			range = 2.5,
			color = vec(0.75, 0.05, 0),
			brightness = 2,
			castShadow = false,
			fillLight = true,
		},
		{
			class = "Light",
			name = "crystal_light_05p1a",
			offset = vec(-0.38, 2.88, 1.11),
			range = 2.5,
			color = vec(0.75, 0.05, 0),
			brightness = 2,
			castShadow = false,
			fillLight = true,
		},
		{
			class = "Light",
			name = "crystal_light_06p1a",
			offset = vec(1.73, 0.71, 0.17),
			range = 2.5,
			color = vec(0.75, 0.05, 0),
			brightness = 2,
			castShadow = false,
			fillLight = true,
		},
		{
			class = "Light",
			name = "crystal_light_07p1a",
			offset = vec(1.17, 1.84, 0.12),
			range = 2.5,
			color = vec(0.75, 0.05, 0),
			brightness = 2,
			castShadow = false,
			fillLight = true,
		},
		{
				class = "Particle",
				particleSystem = "rc_crystal_small",
				emitterMesh = "mod_assets/vanblam/red_cave/models/env/rc_pillar_01a_crystal_mesh.fbx",
		},
		{
			class = "Occluder",
			model = "assets/models/env/mine_pillar_01_occluder.fbx",
		},
	},
	minimalSaveState = true,
	editorIcon = 92,
	tags = { "red cave", "vanblam" },
}

defineObject{
	name = "rc_pillar_01a_hatless",
	baseObject = "base_floor_decoration",
	components = {
		{
			class = "Model",
			model = "mod_assets/vanblam/red_cave/models/env/rc_pillar_01a_hatless.fbx",
			staticShadow = true,
		},
		{
			class = "Light",
			name = "crystal_light_01p1a",
			offset = vec(-0.61, 0.9, -1.2),
			range = 2.5,
			color = vec(0.75, 0.05, 0),
			brightness = 2,
			castShadow = false,
			fillLight = true,
		},
		{
			class = "Light",
			name = "crystal_light_02p1a",
			offset = vec(-0.38, 3.09, -1.37),
			range = 2.5,
			color = vec(0.75, 0.05, 0),
			brightness = 2,
			castShadow = false,
			fillLight = true,
		},
		{
			class = "Light",
			name = "crystal_light_03p1a",
			offset = vec(-1.3, 1.24, 0.4),
			range = 2.5,
			color = vec(0.75, 0.05, 0),
			brightness = 2,
			castShadow = false,
			fillLight = true,
		},
		{
			class = "Light",
			name = "crystal_light_04p1a",
			offset = vec(0.23, 1.15, 1.26),
			range = 2.5,
			color = vec(0.75, 0.05, 0),
			brightness = 2,
			castShadow = false,
			fillLight = true,
		},
		{
			class = "Light",
			name = "crystal_light_05p1a",
			offset = vec(-0.38, 2.88, 1.11),
			range = 2.5,
			color = vec(0.75, 0.05, 0),
			brightness = 2,
			castShadow = false,
			fillLight = true,
		},
		{
			class = "Light",
			name = "crystal_light_06p1a",
			offset = vec(1.73, 0.71, 0.17),
			range = 2.5,
			color = vec(0.75, 0.05, 0),
			brightness = 2,
			castShadow = false,
			fillLight = true,
		},
		{
			class = "Light",
			name = "crystal_light_07p1a",
			offset = vec(1.17, 1.84, 0.12),
			range = 2.5,
			color = vec(0.75, 0.05, 0),
			brightness = 2,
			castShadow = false,
			fillLight = true,
		},
		{
				class = "Particle",
				particleSystem = "rc_crystal_small",
				emitterMesh = "mod_assets/vanblam/red_cave/models/env/rc_pillar_01a_hatless_cm.fbx",
		},
		{
			class = "Occluder",
			model = "assets/models/env/mine_pillar_01_occluder.fbx",
		},
	},
	minimalSaveState = true,
	editorIcon = 92,
	tags = { "red cave", "vanblam" },
}

defineObject{
	name = "rc_pillar_01b",
	baseObject = "base_floor_decoration",
	components = {
		{
			class = "Model",
			model = "mod_assets/vanblam/red_cave/models/env/rc_pillar_01b.fbx",
			staticShadow = true,
		},
		{
			class = "Light",
			name = "crystal_light_01p1b",
			offset = vec(-0.43, 1.31, 1.3),
			range = 2.5,
			color = vec(0.75, 0.05, 0),
			brightness = 2,
			castShadow = false,
			fillLight = true,
		},
		{
			class = "Light",
			name = "crystal_light_02p1b",
			offset = vec(0.11, 2.37, 1.25),
			range = 2.5,
			color = vec(0.75, 0.05, 0),
			brightness = 2,
			castShadow = false,
			fillLight = true,
		},
		{
			class = "Light",
			name = "crystal_light_03p1b",
			offset = vec(0.89, 1.39, 0.65),
			range = 2.5,
			color = vec(0.75, 0.05, 0),
			brightness = 2,
			castShadow = false,
			fillLight = true,
		},
		{
			class = "Light",
			name = "crystal_light_04p1b",
			offset = vec(1.29, 2.6, -0.11),
			range = 2.5,
			color = vec(0.75, 0.05, 0),
			brightness = 2,
			castShadow = false,
			fillLight = true,
		},
		{
			class = "Light",
			name = "crystal_light_05p1b",
			offset = vec(-0.03, 2.57, -1.14),
			range = 2.5,
			color = vec(0.75, 0.05, 0),
			brightness = 2,
			castShadow = false,
			fillLight = true,
		},
		{
			class = "Light",
			name = "crystal_light_06p1b",
			offset = vec(0, 0.76, -1.36),
			range = 2.5,
			color = vec(0.75, 0.05, 0),
			brightness = 2,
			castShadow = false,
			fillLight = true,
		},
		{
			class = "Light",
			name = "crystal_light_07p1b",
			offset = vec(-1.35, 2.87, 0.39),
			range = 2.5,
			color = vec(0.75, 0.05, 0),
			brightness = 2,
			castShadow = false,
			fillLight = true,
		},
		{
				class = "Particle",
				particleSystem = "rc_crystal_small",
				emitterMesh = "mod_assets/vanblam/red_cave/models/env/rc_pillar_01b_crystal_mesh.fbx",
		},
		{
			class = "Occluder",
			model = "assets/models/env/mine_pillar_01_occluder.fbx",
		},
	},
	minimalSaveState = true,
	editorIcon = 92,
	tags = { "red cave", "vanblam" },
}

defineObject{
	name = "rc_pillar_01b_hatless",
	baseObject = "base_floor_decoration",
	components = {
		{
			class = "Model",
			model = "mod_assets/vanblam/red_cave/models/env/rc_pillar_01b_hatless.fbx",
			staticShadow = true,
		},
		{
			class = "Light",
			name = "crystal_light_01p1b",
			offset = vec(-0.43, 1.31, 1.3),
			range = 2.5,
			color = vec(0.75, 0.05, 0),
			brightness = 2,
			castShadow = false,
			fillLight = true,
		},
		{
			class = "Light",
			name = "crystal_light_02p1b",
			offset = vec(0.11, 2.37, 1.25),
			range = 2.5,
			color = vec(0.75, 0.05, 0),
			brightness = 2,
			castShadow = false,
			fillLight = true,
		},
		{
			class = "Light",
			name = "crystal_light_03p1b",
			offset = vec(0.89, 1.39, 0.65),
			range = 2.5,
			color = vec(0.75, 0.05, 0),
			brightness = 2,
			castShadow = false,
			fillLight = true,
		},
		{
			class = "Light",
			name = "crystal_light_04p1b",
			offset = vec(1.29, 2.6, -0.11),
			range = 2.5,
			color = vec(0.75, 0.05, 0),
			brightness = 2,
			castShadow = false,
			fillLight = true,
		},
		{
			class = "Light",
			name = "crystal_light_05p1b",
			offset = vec(-0.03, 2.57, -1.14),
			range = 2.5,
			color = vec(0.75, 0.05, 0),
			brightness = 2,
			castShadow = false,
			fillLight = true,
		},
		{
			class = "Light",
			name = "crystal_light_06p1b",
			offset = vec(0, 0.76, -1.36),
			range = 2.5,
			color = vec(0.75, 0.05, 0),
			brightness = 2,
			castShadow = false,
			fillLight = true,
		},
		{
			class = "Light",
			name = "crystal_light_07p1b",
			offset = vec(-1.35, 2.87, 0.39),
			range = 2.5,
			color = vec(0.75, 0.05, 0),
			brightness = 2,
			castShadow = false,
			fillLight = true,
		},
		{
				class = "Particle",
				particleSystem = "rc_crystal_small",
				emitterMesh = "mod_assets/vanblam/red_cave/models/env/rc_pillar_01b_hatless_cm.fbx",
		},
		{
			class = "Occluder",
			model = "assets/models/env/mine_pillar_01_occluder.fbx",
		},
	},
	minimalSaveState = true,
	editorIcon = 92,
	tags = { "red cave", "vanblam" },
}

defineObject{
	name = "rc_pillar_02a",
	baseObject = "base_floor_decoration",
	components = {
		{
			class = "Model",
			model = "mod_assets/vanblam/red_cave/models/env/rc_pillar_02a.fbx",
			staticShadow = true,
		},
	},
	minimalSaveState = true,
	editorIcon = 92,
	tags = { "red cave", "vanblam" },
}

defineObject{
	name = "rc_pillar_02a_center",
	baseObject = "base_pillar",
	components = {
		{
			class = "Model",
			model = "mod_assets/vanblam/red_cave/models/env/rc_pillar_02a.fbx",
			staticShadow = true,
		},
	},
	minimalSaveState = true,
	editorIcon = 108,
	tags = { "red cave", "vanblam" },
}

defineObject{
	name = "rc_pillar_01a_saved",
	baseObject = "base_floor_decoration",
	components = {
		{
			class = "Model",
			model = "mod_assets/vanblam/red_cave/models/env/rc_pillar_01a.fbx",
			staticShadow = true,
		},
		{
			class = "Light",
			name = "crystal_light_01p1a",
			offset = vec(-0.61, 0.9, -1.2),
			range = 2.5,
			color = vec(0.75, 0.05, 0),
			brightness = 2,
			castShadow = false,
			fillLight = true,
		},
		{
			class = "Light",
			name = "crystal_light_02p1a",
			offset = vec(-0.38, 3.09, -1.37),
			range = 2.5,
			color = vec(0.75, 0.05, 0),
			brightness = 2,
			castShadow = false,
			fillLight = true,
		},
		{
			class = "Light",
			name = "crystal_light_03p1a",
			offset = vec(-1.3, 1.24, 0.4),
			range = 2.5,
			color = vec(0.75, 0.05, 0),
			brightness = 2,
			castShadow = false,
			fillLight = true,
		},
		{
			class = "Light",
			name = "crystal_light_04p1a",
			offset = vec(0.23, 1.15, 1.26),
			range = 2.5,
			color = vec(0.75, 0.05, 0),
			brightness = 2,
			castShadow = false,
			fillLight = true,
		},
		{
			class = "Light",
			name = "crystal_light_05p1a",
			offset = vec(-0.38, 2.88, 1.11),
			range = 2.5,
			color = vec(0.75, 0.05, 0),
			brightness = 2,
			castShadow = false,
			fillLight = true,
		},
		{
			class = "Light",
			name = "crystal_light_06p1a",
			offset = vec(1.73, 0.71, 0.17),
			range = 2.5,
			color = vec(0.75, 0.05, 0),
			brightness = 2,
			castShadow = false,
			fillLight = true,
		},
		{
			class = "Light",
			name = "crystal_light_07p1a",
			offset = vec(1.17, 1.84, 0.12),
			range = 2.5,
			color = vec(0.75, 0.05, 0),
			brightness = 2,
			castShadow = false,
			fillLight = true,
		},
		{
				class = "Particle",
				particleSystem = "rc_crystal_small",
				emitterMesh = "mod_assets/vanblam/red_cave/models/env/rc_pillar_01a_crystal_mesh.fbx",
		},
		{
			class = "Occluder",
			model = "assets/models/env/mine_pillar_01_occluder.fbx",
		},
	},
	minimalSaveState = true,
	editorIcon = 92,
	tags = { "red cave", "vanblam" },
}

defineObject{
	name = "rc_pillar_01b_saved",
	baseObject = "base_floor_decoration",
	components = {
		{
			class = "Model",
			model = "mod_assets/vanblam/red_cave/models/env/rc_pillar_01b.fbx",
			staticShadow = true,
		},
		{
			class = "Light",
			name = "crystal_light_01p1b",
			offset = vec(-0.43, 1.31, 1.3),
			range = 2.5,
			color = vec(0.75, 0.05, 0),
			brightness = 2,
			castShadow = false,
			fillLight = true,
		},
		{
			class = "Light",
			name = "crystal_light_02p1b",
			offset = vec(0.11, 2.37, 1.25),
			range = 2.5,
			color = vec(0.75, 0.05, 0),
			brightness = 2,
			castShadow = false,
			fillLight = true,
		},
		{
			class = "Light",
			name = "crystal_light_03p1b",
			offset = vec(0.89, 1.39, 0.65),
			range = 2.5,
			color = vec(0.75, 0.05, 0),
			brightness = 2,
			castShadow = false,
			fillLight = true,
		},
		{
			class = "Light",
			name = "crystal_light_04p1b",
			offset = vec(1.29, 2.6, -0.11),
			range = 2.5,
			color = vec(0.75, 0.05, 0),
			brightness = 2,
			castShadow = false,
			fillLight = true,
		},
		{
			class = "Light",
			name = "crystal_light_05p1b",
			offset = vec(-0.03, 2.57, -1.14),
			range = 2.5,
			color = vec(0.75, 0.05, 0),
			brightness = 2,
			castShadow = false,
			fillLight = true,
		},
		{
			class = "Light",
			name = "crystal_light_06p1b",
			offset = vec(0, 0.76, -1.36),
			range = 2.5,
			color = vec(0.75, 0.05, 0),
			brightness = 2,
			castShadow = false,
			fillLight = true,
		},
		{
			class = "Light",
			name = "crystal_light_07p1b",
			offset = vec(-1.35, 2.87, 0.39),
			range = 2.5,
			color = vec(0.75, 0.05, 0),
			brightness = 2,
			castShadow = false,
			fillLight = true,
		},
		{
				class = "Particle",
				particleSystem = "rc_crystal_small",
				emitterMesh = "mod_assets/vanblam/red_cave/models/env/rc_pillar_01b_crystal_mesh.fbx",
		},
		{
			class = "Occluder",
			model = "assets/models/env/mine_pillar_01_occluder.fbx",
		},
	},
	minimalSaveState = true,
	editorIcon = 92,
	tags = { "red cave", "vanblam" },
}

defineObject{
	name = "rc_pillar_02a_saved",
	baseObject = "base_floor_decoration",
	components = {
		{
			class = "Model",
			model = "mod_assets/vanblam/red_cave/models/env/rc_pillar_02a.fbx",
			staticShadow = true,
		},
		{
			class = "Occluder",
			model = "assets/models/env/mine_pillar_01_occluder.fbx",
		},
	},
	minimalSaveState = true,
	editorIcon = 92,
	tags = { "red cave", "vanblam" },
}