-- Functional --
-- Pressure Plates - Contraptions - Buttons - Levers - Shafts - Stairs --

defineObject{
	name = "rc_ladder",
	baseObject = "base_wall_decoration",
	components = {
		{
			class = "Model",
			model = "mod_assets/vanblam/red_cave/models/env/rc_ladder.fbx",
			offset = vec(0,0,-0.4),
		},
		{
			class = "Ladder",
		},
		{
			class = "Clickable",
			offset = vec(0, 1.6, -0.4),
			size = vec(0.8, 1.6, 0.4),
			frontFacing = true,
			--debugDraw = true,
		},
	},
	editorIcon = 248,
	automapIcon = 140,
	tags = { "red cave", "vanblam" },
}

defineObject{
	name = "rc_molten_floaty_ao_ni", -- animation to bring to serface, no idle.
	components = {
		{
			class = "Model",
			model = "mod_assets/vanblam/red_cave/models/env/rc_molten_floaty.fbx",
			staticShadow = true,
		},
		{
			class = "Animation",
			animations = {
			startpoint = "mod_assets/vanblam/red_cave/animations/rc_molten_floaty_start.fbx",
			move = "mod_assets/vanblam/red_cave/animations/rc_molten_floaty_move.fbx",
			},
			loop = false,
			playOnInit = "startpoint",
		},
		{
			class = "Controller",
			onActivate = function(self)
				self.go.animation:play("move")
			end,
		},
	},
	placement = "floor",
	editorIcon = 80,
	tags = { "red cave", "vanblam" },
}

defineObject{
	name = "rc_molten_floaty_idle_no_effect",
	components = {
		{
			class = "Model",
			model = "mod_assets/vanblam/red_cave/models/env/rc_molten_floaty.fbx",
			staticShadow = true,
		},
		{
			class = "Animation",
			animations = {
			idle = "mod_assets/vanblam/red_cave/animations/rc_molten_floaty_idle.fbx",
			},
			loop = true,
			playOnInit = "idle",
		},
		{
			class = "Platform",
		},
	},
	placement = "floor",
	automapIcon = 136,
	editorIcon = 276,
	tags = { "red cave", "vanblam" },
	minimalSaveState = true,
}


defineObject{
	name = "rc_molten_floaty_idle",
	components = {
		{
			class = "Model",
			model = "mod_assets/vanblam/red_cave/models/env/rc_molten_floaty.fbx",
			staticShadow = true,
		},
		{
			class = "Animation",
			animations = {
			idle = "mod_assets/vanblam/red_cave/animations/rc_molten_floaty_idle.fbx",
			},
			loop = true,
			playOnInit = "idle",
		},
		{
			class = "Platform",
		},
		{
			class = "Particle",
			particleSystem = "floaty_effect",
			emitterMesh = "mod_assets/vanblam/red_cave/models/env/rc_molten_floaty.fbx",
		},
	},
	placement = "floor",
	editorIcon = 276,
	automapIcon = 136,
	tags = { "red cave", "vanblam" },
	minimalSaveState = true,
}

defineParticleSystem{
	name = "floaty_effect",
	emitters = {
		-- fog
		{
			emitterShape = "MeshShape",
			emissionRate = 10,
			emissionTime = 0,
			maxParticles = 100,
			boxMin = {-1.5, 0.0,-1.5},
			boxMax = { 1.5, -0.05, 1.5},
			sprayAngle = {0,360},
			velocity = {0.1,0.4},
			objectSpace = true,
			texture = "assets/textures/particles/fog.tga",
			lifetime = {3,3},
			color0 = {1, 0.25, 0},
			opacity = 0.2,
			fadeIn = 2,
			fadeOut = 2,
			size = {1, 2},
			gravity = {0,0,0},
			airResistance = 0.1,
			rotationSpeed = 0.3,
			blendMode = "Additive",
		},

		-- stars
		{
			emitterShape = "MeshShape",
			emissionRate = 100,
			emissionTime = 0,
			maxParticles = 200,
			boxMin = {-1.5,0.0,-1.5},
			boxMax = { 1.5,-0.05, 1.5},
			sprayAngle = {0,30},
			velocity = {0.0,0.1},
			objectSpace = true,
			texture = "assets/textures/particles/glitter_silver.tga",
			lifetime = {1,1.7},
			color0 = {1,0.25,0},
			opacity = 1,
			fadeIn = 0.1,
			fadeOut = 0.5,
			size = {0.05, 0.15},
			gravity = {0,0.5,0},
			airResistance = 0.1,
			rotationSpeed = 2,
			blendMode = "Additive",
		},

		-- stars
		{
			emitterShape = "MeshShape",
			emissionRate = 400,
			emissionTime = 0,
			maxParticles = 400,
			boxMin = {-1.5,0.0,-1.5},
			boxMax = { 1.5,-0.05, 1.5},
			sprayAngle = {0,30},
			velocity = {0.0,0.1},
			objectSpace = true,
			texture = "assets/textures/particles/glitter_silver.tga",
			lifetime = {1,1},
			color0 = {1*1.5, 0.25*1.5, 0*1.5},
			opacity = 1,
			fadeIn = 0.1,
			fadeOut = 0.5,
			size = {0.05, 0.25},
			gravity = {0,0.2,0},
			airResistance = 0.1,
			rotationSpeed = 2,
			blendMode = "Additive",
		},
	}
}

defineObject{
	name = "rc_stone_lock_01",
	components = {
		{
			class = "Model",
			model = "mod_assets/vanblam/red_cave/models/env/rc_stone_lock_01.fbx",
			staticShadow = true,
		},
		{
			class = "Clickable",
			offset = vec(0, 1.3, 0),
			size = vec(0.3, 0.3, 0.3),
			--debugDraw = true,
		},
		{
			class = "Lock",
			sound = "key_lock",
		},
		
	},
	placement = "wall",
	editorIcon = 20,
	tags = { "red cave", "vanblam" },
}
defineObject{
	name = "rc_lock_01",
	components = {
		{
			class = "Model",
			model = "mod_assets/vanblam/red_cave/models/env/rc_lock_01.fbx",
			staticShadow = true,
		},
		{
			class = "Clickable",
			offset = vec(0, 1.33, 0),
			size = vec(0.3, 0.4, 0.3),
			--debugDraw = true,
		},
		{
			class = "Lock",
			sound = "key_lock",
		},
		
	},
	placement = "wall",
	editorIcon = 20,
	tags = { "red cave", "vanblam" },
}

defineObject{
	name = "rc_lock_01_pillar_2a_center",
	components = {
		{
			class = "Model",
			model = "mod_assets/vanblam/red_cave/models/env/rc_lock_01.fbx",
			offset = vec(1.5,0,-0.55),
			staticShadow = true,
		},
		{
			class = "Clickable",
			offset = vec(1.5, 1.33,-0.55),
			size = vec(0.3, 0.4, 0.3),
			--debugDraw = true,
		},
		{
			class = "Lock",
			sound = "key_lock",
		},
		
	},
	placement = "wall",
	editorIcon = 20,
	tags = { "red cave", "vanblam" },
}

defineObject{
	name = "rc_floor_plate",
	baseObject = "base_pressure_plate",
	components = {
		{
			class = "Model",
			model = "mod_assets/vanblam/red_cave/models/env/rc_floor_plate.fbx",
			staticShadow = true,
		},
		{
			class = "Animation",
			animations = {
				activate = "assets/animations/env/forest_pressure_plate_down.fbx",
				deactivate = "assets/animations/env/forest_pressure_plate_up.fbx",
			},
		},
		{
			class = "Model",
			name = "base",
			model = "mod_assets/vanblam/red_cave/models/env/rc_floor_plate_base.fbx",
			staticShadow = true,
		},
	},
	tags = { "red cave", "vanblam" },
}

defineObject{
	name = "rc_ceiling_shaft",
	baseObject = "base_ceiling_shaft",
	components = {
		{
			class = "Null",
			name = "auto_destroy_objects",
			onInit = function(self)
				local x = self.go.x
				local y = self.go.y
				local facing = self.go.facing
				local level = self.go.level
				
				local fx,fy = getForward(facing)
				local rx,ry = getForward((facing+1)%4)

				for yy=-1,1 do
					for xx=-1,1 do
						local x = x + rx * xx + fx * yy
						local y = y + ry * xx + fy * yy
						if x >= 0 and y >= 0 and x < 32 and y < 32 then
							for e in self.go.map:entitiesAt(x, y) do
								if e.name == "rc_ceiling_01a" 
								or e.name == "rc_ceiling_01b" 
								or e.name == "rc_ceiling_01c"
								or e.name == "rc_ceiling_01d"
								or e.name == "rc_ceiling_01e"
								or e.name == "rc_ceiling_slope"								
								then e:destroy()
								end
							end
						end
					end
				end
				for yy=0,0 do
					for xx=-1,1 do
						local x = x + rx * xx + fx * yy
						local y = y + ry * xx + fy * yy
						if x >= 0 and y >= 0 and x < 32 and y < 32 then
							for e in self.go.map:entitiesAt(x, y) do
								if e.name == "rc_edge_support_01"
								or e.name == "rc_edge_support_02"
								or e.name == "rc_edge_support_03"
								or e.name == "rc_edge_support_04"
								or e.name == "rc_edge_support_01b"
								or e.name == "rc_edge_support_02b"
								or e.name == "rc_edge_support_03b"
								or e.name == "rc_edge_support_04b"								
								then e:destroy()
								end
							end
						end
					end
				end
				for yy=-1,1 do
					for xx=-1,1 do
						local x = x + rx * xx + fx * yy
						local y = y + ry * xx + fy * yy
						local choice = math.random()
						if x >= 0 and y >= 0 and x < 32 and y < 32 then
							for e in self.go.map:entitiesAt(x, y) do
								if e.name == "rc_pillar_01a" 
								or e.name == "rc_pillar_01b"							
								then e:destroy()
									if choice >= 0.66 then
											spawn("rc_pillar_01a_hatless", level, x, y,math.random(0,3), self.go.elevation)
										elseif choice >= 0.33 then
											spawn("rc_pillar_01b_hatless", level, x, y,math.random(0,3), self.go.elevation)
										else
											spawn("rc_pillar_02a", level, x, y,math.random(0,3), self.go.elevation)
										
									end
								end
							end
						end
					end
				end
				self.go:spawn("rc_ceiling_shaft_real")
			end,
		},
		
	},
	tags = { "red cave", "vanblam" },
}

defineObject{
	name = "rc_ceiling_shaft_real",
	components = {
		{
			class = "Model",
			model = "mod_assets/vanblam/red_cave/models/env/rc_ceiling_shaft.fbx",
			staticShadow = true,
		},
	},
	minimalSaveState = true,
	replacesCeiling = true,
	placement = "ceiling",
}

defineObject{
	name = "rc_stone_ceiling_shaft",
	baseObject = "base_ceiling_shaft",
	components = {
		{
			class = "Null",
			name = "auto_destroy_objects",
			onInit = function(self)
				local x = self.go.x
				local y = self.go.y
				local facing = self.go.facing
				local level = self.go.level
				
				local fx,fy = getForward(facing)
				local rx,ry = getForward((facing+1)%4)

				-- destroy other ceilings in a 3x3 area
				for yy=-1,1 do
					for xx=-1,1 do
						local x = x + rx * xx + fx * yy
						local y = y + ry * xx + fy * yy
						if x >= 0 and y >= 0 and x < 32 and y < 32 then
							for e in self.go.map:entitiesAt(x, y) do
								if e.name == "rc_ceiling_01a" 
								or e.name == "rc_ceiling_01b" 
								or e.name == "rc_ceiling_01c"
								or e.name == "rc_ceiling_01d"
								or e.name == "rc_ceiling_01e"
								or e.name == "rc_ceiling_slope"								
								then e:destroy()
								end
							end
						end
					end
				end
				for yy=0,0 do
					for xx=-1,1 do
						local x = x + rx * xx + fx * yy
						local y = y + ry * xx + fy * yy
						if x >= 0 and y >= 0 and x < 32 and y < 32 then
							for e in self.go.map:entitiesAt(x, y) do
								if e.name == "rc_edge_support_01"
								or e.name == "rc_edge_support_02"
								or e.name == "rc_edge_support_03"
								or e.name == "rc_edge_support_04"
								or e.name == "rc_edge_support_01b"
								or e.name == "rc_edge_support_02b"
								or e.name == "rc_edge_support_03b"
								or e.name == "rc_edge_support_04b"								
								then e:destroy()
								end
							end
						end
					end
				end
				for yy=-1,1 do
					for xx=-1,1 do
						local x = x + rx * xx + fx * yy
						local y = y + ry * xx + fy * yy
						local choice = math.random()
						if x >= 0 and y >= 0 and x < 32 and y < 32 then
							for e in self.go.map:entitiesAt(x, y) do
								if e.name == "rc_pillar_01a" 
								or e.name == "rc_pillar_01b"							
								then e:destroy()
									if choice >= 0.66 then
											spawn("rc_pillar_01a_hatless", level, x, y,math.random(0,3), self.go.elevation)
										elseif choice >= 0.33 then
											spawn("rc_pillar_01b_hatless", level, x, y,math.random(0,3), self.go.elevation)
										else
											spawn("rc_pillar_02a", level, x, y,math.random(0,3), self.go.elevation)
										
									end
								end
							end
						end
					end
				end
				self.go:spawn("rc_stone_ceiling_shaft_real")
			end,
		},
		
	},
	tags = { "red cave", "vanblam" },
}

defineObject{
	name = "rc_stone_ceiling_shaft_real",
	components = {
		{
			class = "Model",
			model = "mod_assets/vanblam/red_cave/models/env/rc_stone_ceiling_shaft.fbx",
			staticShadow = true,
		},
	},
	minimalSaveState = true,
	replacesCeiling = true,
	placement = "ceiling",
}

defineObject{
	name = "rc_floor_shaft",
	components = {
		{
			class = "Pit",
		},
		{
			class = "Null",
			name = "auto_destroy_objects",
			onInit = function(self)
				local x = self.go.x
				local y = self.go.y
				local facing = self.go.facing
				local level = self.go.level
				
				local fx,fy = getForward(facing)
				local rx,ry = getForward((facing+1)%4)

				-- destroy other ceilings in a 3x3 area
				for yy=-1,1 do
					for xx=-1,1 do
						local x = x + rx * xx + fx * yy
						local y = y + ry * xx + fy * yy
						if x >= 0 and y >= 0 and x < 32 and y < 32 then
							for e in self.go.map:entitiesAt(x, y) do
								if e.name == "rc_pillar_01a" 
								or e.name == "rc_pillar_01b"
								or e.name == "rc_pillar_01a_hatless"
								or e.name == "rc_pillar_01b_hatless"								
								then e:destroy()
								spawn("rc_pillar_02a", level, x, y, math.random(0,3), self.go.elevation)
								end
							end
						end
					end
				end
				self.go:spawn("rc_floor_shaft_real")
			end,
		},
		
	},
	replacesFloor = true,
	killHeightmap = true,
	placement = "floor",
	editorIcon = 40,
	automapIcon = 108,
	tags = { "red cave", "vanblam" },
}

defineObject{
	name = "rc_floor_shaft_real",
	components = {
		{
			class = "Model",
			offset = vec(0, -0.09, 0),
			model = "mod_assets/vanblam/red_cave/models/env/rc_floor_shaft.fbx",
			staticShadow = true,
		},
	},
	minimalSaveState = true,
	replacesFloor = true,
	placement = "floor",
	automapIcon = 108,
}

defineObject{
	name = "rc_stone_floor_shaft",
	components = {
		{
			class = "Pit",
		},
		{
			class = "Null",
			name = "auto_destroy_objects",
			onInit = function(self)
				local x = self.go.x
				local y = self.go.y
				local facing = self.go.facing
				local level = self.go.level
				
				local fx,fy = getForward(facing)
				local rx,ry = getForward((facing+1)%4)

				-- destroy other ceilings in a 3x3 area
				for yy=-1,1 do
					for xx=-1,1 do
						local x = x + rx * xx + fx * yy
						local y = y + ry * xx + fy * yy
						if x >= 0 and y >= 0 and x < 32 and y < 32 then
							for e in self.go.map:entitiesAt(x, y) do
								if e.name == "rc_pillar_01a" 
								or e.name == "rc_pillar_01b"
								or e.name == "rc_pillar_01a_hatless"
								or e.name == "rc_pillar_01b_hatless"								
								then e:destroy()
								spawn("rc_pillar_02a", level, x, y, math.random(0,3), self.go.elevation)
								end
							end
						end
					end
				end
				for yy=-1,1 do
					for xx=-1,1 do
						local x = x + rx * xx + fx * yy
						local y = y + ry * xx + fy * yy
						if x >= 0 and y >= 0 and x < 32 and y < 32 then
							for e in self.go.map:entitiesAt(x, y) do
								if e.name == "rc_wall_slope"
								then e:destroy()								
								end
							end
						end
					end
				end
				self.go:spawn("rc_stone_floor_shaft_real")
			end,
		},
		
	},
	replacesFloor = true,
	killHeightmap = true,
	placement = "floor",
	editorIcon = 40,
	automapIcon = 108,
	tags = { "red cave", "vanblam" },
}

defineObject{
	name = "rc_stone_floor_shaft_real",
	components = {
		{
			class = "Model",
			model = "mod_assets/vanblam/red_cave/models/env/rc_stone_floor_shaft.fbx",
			staticShadow = true,
		},
	},
	minimalSaveState = true,
	replacesFloor = true,
	placement = "floor",
	automapIcon = 108,
}

defineObject{
	name = "rc_stone_floor_trap_door",
	baseObject = "base_pit_trapdoor",
	components = {
		{
			class = "Model",
			model = "mod_assets/vanblam/red_cave/models/env/rc_stone_floor_trap_door.fbx",
			staticShadow = true,
		},
		{
			class = "Animation",
			animations = {
				open = "mod_assets/vanblam/red_cave/animations/rc_stone_floor_trap_door_open.fbx",
				close = "mod_assets/vanblam/red_cave/animations/rc_stone_floor_trap_door_close.fbx",
			},
		},
		{
			class = "Occluder",
			model = "assets/models/env/dungeon_pit_occluder.fbx",
		},
	},
	tags = { "red cave", "vanblam" },
}

defineObject{
	name = "rc_stone_stairs_up",
	baseObject = "base_stairs_up",
	components = {
		{
			class = "Model",
			model = "mod_assets/vanblam/red_cave/models/env/rc_stone_stairs_up.fbx",
			staticShadow = true,
		},
		{
			class = "Null",
			name = "auto_destroy_objects",
			onInit = function(self)
				local x = self.go.x
				local y = self.go.y
				local facing = self.go.facing
				local level = self.go.level
				
				local fx,fy = getForward(facing)
				local rx,ry = getForward((facing+1)%4)

				do				
					local x = self.go.x + fx
					local y = self.go.y + fy
					if x >= 0 and y >= 0 and x < 32 and y < 32 then
						self.go.map:setAutomapTile(x, y, 4)	-- rocky wall
					end
				end

				-- destroy all pillars and slopes
				for yy=0,4 do
					for xx=-1,1 do
						local x = x + rx * xx + fx * yy
						local y = y + ry * xx + fy * yy
						if x >= 0 and y >= 0 and x < 32 and y < 32 then
							for e in self.go.map:entitiesAt(x, y) do
								if e.name == "rc_pillar_01a" 
								or e.name == "rc_pillar_01b"  
						    	then
								e:destroy()
								spawn("rc_pillar_02a", level, x, y, math.random(0,3), self.go.elevation)
								end
							end
						end
					end
				end
				for e in self.go.map:entitiesAt(x, y) do				
				spawn("rc_ground_01", level, x, y, math.random(0,3), self.go.elevation)			
				end
				for yy=0,4 do
					for xx=-0,0 do
						local x = x + rx * xx + fx * yy
						local y = y + ry * xx + fy * yy
						if x >= 0 and y >= 0 and x < 32 and y < 32 then
							for e in self.go.map:entitiesAt(x, y) do
								if e.name == "rc_pillar_02a"  
						    	then
								e:destroy()
								end
							end
						end
					end
				end
				for yy=1,4 do
					for xx=-1,1 do
						local x = x + rx * xx + fx * yy
						local y = y + ry * xx + fy * yy
						if x >= 0 and y >= 0 and x < 32 and y < 32 then
							for e in self.go.map:entitiesAt(x, y) do
								if e.name == "rc_wall_01a"
								or e.name == "rc_wall_01b" 
								or e.name == "rc_wall_01c"
								or e.name == "rc_wall_02a"
								or e.name == "rc_wall_02b"								
						    	then
								e:destroy()
								end
							end
						end
					end
				end
			for yy=0,4 do
					for xx=-1,1 do
						local x = x + rx * xx + fx * yy
						local y = y + ry * xx + fy * yy
						if x >= 0 and y >= 0 and x < 32 and y < 32 then
							for e in self.go.map:entitiesAt(x, y) do
								if e.name == "rc_edge_support_01" 
								or e.name == "rc_edge_support_02" 
								or e.name == "rc_edge_support_03"
								or e.name == "rc_edge_support_04"
								or e.name == "rc_edge_support_01b"
								or e.name == "rc_edge_support_02b"
								or e.name == "rc_edge_support_03b"
								or e.name == "rc_edge_support_04b"
								or e.name == "rc_ceiling_01a" 
								or e.name == "rc_ceiling_01b" 
								or e.name == "rc_ceiling_01c"
								or e.name == "rc_ceiling_01d"
								or e.name == "rc_ceiling_01e"
								or e.name == "rc_wall_slope"
								or e.name == "rc_ceiling_slope" 
						    	then
								e:destroy()
								end
							end
						end
					end
				end
			end
		},
	},
	tags = { "red cave", "vanblam" },
}

defineObject{
	name = "rc_stone_stairs_down",
	baseObject = "base_stairs_down",
	components = {
		{
			class = "Model",
			model = "mod_assets/vanblam/red_cave/models/env/rc_stone_stairs_down.fbx",
			staticShadow = true,
		},
		{
			class = "Null",
			name = "auto_destroy_objects",
			onInit = function(self)
				local x = self.go.x
				local y = self.go.y
				local facing = self.go.facing
				local level = self.go.level
				
				local fx,fy = getForward(facing)
				local rx,ry = getForward((facing+1)%4)

				do				
					local x = self.go.x + fx
					local y = self.go.y + fy
					if x >= 0 and y >= 0 and x < 32 and y < 32 then
						self.go.map:setAutomapTile(x, y, 4)	-- rocky wall
					end
				end

				-- destroy all pillars and slopes
				for yy=0,4 do
					for xx=-1,1 do
						local x = x + rx * xx + fx * yy
						local y = y + ry * xx + fy * yy
						if x >= 0 and y >= 0 and x < 32 and y < 32 then
							for e in self.go.map:entitiesAt(x, y) do
								if e.name == "rc_pillar_01a" 
								or e.name == "rc_pillar_01b"  
						    	then
								e:destroy()
								spawn("rc_pillar_02a", level, x, y, math.random(0,3), self.go.elevation)
								end
							end
						end
					end
				end
				-- for e in self.go.map:entitiesAt(x, y) do				
				-- spawn("rc_ground_01", level, x, y, math.random(0,3), self.go.elevation)			
				-- end
				for yy=0,3 do
					for xx=-0,0 do
						local x = x + rx * xx + fx * yy
						local y = y + ry * xx + fy * yy
						if x >= 0 and y >= 0 and x < 32 and y < 32 then
							for e in self.go.map:entitiesAt(x, y) do
								if e.name == "rc_pillar_02a"  
						    	then
								e:destroy()
								end
							end
						end
					end
				end
				for yy=1,3 do
					for xx=-1,1 do
						local x = x + rx * xx + fx * yy
						local y = y + ry * xx + fy * yy
						if x >= 0 and y >= 0 and x < 32 and y < 32 then
							for e in self.go.map:entitiesAt(x, y) do
								if e.name == "rc_wall_01a"
								or e.name == "rc_wall_01b" 
								or e.name == "rc_wall_01c"
								or e.name == "rc_wall_02a"
								or e.name == "rc_wall_02b"
								or e.name == "rc_ground_01"
								or e.name == "rc_ground_02"
								or e.name == "rc_ground_01_real"
								or e.name == "rc_ground_02_real"								
						    	then
								e:destroy()
								end
							end
						end
					end
				end
			for yy=0,3 do
					for xx=-1,1 do
						local x = x + rx * xx + fx * yy
						local y = y + ry * xx + fy * yy
						if x >= 0 and y >= 0 and x < 32 and y < 32 then
							for e in self.go.map:entitiesAt(x, y) do
								if e.name == "rc_edge_support_01" 
								or e.name == "rc_edge_support_02" 
								or e.name == "rc_edge_support_03"
								or e.name == "rc_edge_support_04"
								or e.name == "rc_edge_support_01b"
								or e.name == "rc_edge_support_02b"
								or e.name == "rc_edge_support_03b"
								or e.name == "rc_edge_support_04b"
								or e.name == "rc_ground_pebbles_01" 
								or e.name == "rc_ground_pebbles_02"
								or e.name == "rc_ground_pebbles_03"
								or e.name == "rc_ground_pebbles_04"
								or e.name == "rc_ground_tiles_01"	
								or e.name == "rc_ground_tiles_02" 
								or e.name == "rc_ground_tiles_03"
								or e.name == "rc_ground_tiles_04"
								or e.name == "rc_ground_tiles_05"
								or e.name == "rc_ground_tiles_06"
								or e.name == "rc_ground_tiles_07"
								or e.name == "rc_grass_01a"
								or e.name == "rc_grass_01b"
								or e.name == "rc_grass_01c"	
								or e.name == "rc_wall_slope"
								or e.name == "rc_ceiling_slope" 
						    	then
								e:destroy()
								end
							end
						end
					end
				end
			end
		},
	},
	tags = { "red cave", "vanblam" },
}

defineObject{
	name = "rc_stairs_up",
	baseObject = "base_stairs_up",
	components = {
		{
			class = "Model",
			model = "mod_assets/vanblam/red_cave/models/env/rc_stairs_up.fbx",
			staticShadow = true,
		},
		{
			class = "Null",
			name = "auto_destroy_objects",
			onInit = function(self)
				local x = self.go.x
				local y = self.go.y
				local facing = self.go.facing
				local level = self.go.level
				
				local fx,fy = getForward(facing)
				local rx,ry = getForward((facing+1)%4)

				do				
					local x = self.go.x + fx
					local y = self.go.y + fy
					if x >= 0 and y >= 0 and x < 32 and y < 32 then
						self.go.map:setAutomapTile(x, y, 4)	-- rocky wall
					end
				end

				-- destroy all pillars and slopes
				for yy=0,0 do
					for xx=-1,-1 do
						local x = x + rx * xx + fx * yy
						local y = y + ry * xx + fy * yy
						if x >= 0 and y >= 0 and x < 32 and y < 32 then
							for e in self.go.map:entitiesAt(x, y) do
							spawn("rc_pillar_01a_hatless", level, x, y, math.random(0,3), self.go.elevation)
                            break							
							end
						end
					end
				end
				for yy=0,0 do
					for xx=1,1 do
						local x = x + rx * xx + fx * yy
						local y = y + ry * xx + fy * yy
						if x >= 0 and y >= 0 and x < 32 and y < 32 then
							for e in self.go.map:entitiesAt(x, y) do
							spawn("rc_pillar_01b_hatless", level, x, y, math.random(0,3), self.go.elevation)
                            break							
							end
						end
					end
				end
				for yy=0,4 do
					for xx=-1,1 do
						local x = x + rx * xx + fx * yy
						local y = y + ry * xx + fy * yy
						if x >= 0 and y >= 0 and x < 32 and y < 32 then
							for e in self.go.map:entitiesAt(x, y) do
								if e.name == "rc_ceiling_01a" 
								or e.name == "rc_ceiling_01b" 
								or e.name == "rc_ceiling_01c"
								or e.name == "rc_ceiling_01d"
								or e.name == "rc_ceiling_01e"
								or e.name == "rc_wall_slope"
								or e.name == "rc_ceiling_slope"
								or e.name == "rc_pillar_01a" 
								or e.name == "rc_pillar_01b"
								or e.name == "rc_pillar_02a" 
								or e.name == "rc_edge_support_01" 
								or e.name == "rc_edge_support_02" 
								or e.name == "rc_edge_support_03"
								or e.name == "rc_edge_support_04"
								or e.name == "rc_edge_support_01b"
								or e.name == "rc_edge_support_02b"
								or e.name == "rc_edge_support_03b"
								or e.name == "rc_edge_support_04b" 								
								then e:destroy()
								end
							end
						end
					end
				end
			end,
		},
	},
	tags = { "red cave", "vanblam" },
}

defineObject{
	name = "rc_stairs_down",
	baseObject = "base_stairs_down",
	components = {
		{
			class = "Model",
			model = "mod_assets/vanblam/red_cave/models/env/rc_stairs_down.fbx",
			staticShadow = true,
		},
		{
			class = "Null",
			name = "auto_destroy_objects",
			onInit = function(self)
				local x = self.go.x
				local y = self.go.y
				local facing = self.go.facing
				local level = self.go.level
				
				local fx,fy = getForward(facing)
				local rx,ry = getForward((facing+1)%4)

				do				
					local x = self.go.x + fx
					local y = self.go.y + fy
					if x >= 0 and y >= 0 and x < 32 and y < 32 then
						self.go.map:setAutomapTile(x, y, 4)	-- rocky wall
					end
				end

				-- destroy all pillars and slopes
				for yy=0,0 do
					for xx=-1,-1 do
						local x = x + rx * xx + fx * yy
						local y = y + ry * xx + fy * yy
						if x >= 0 and y >= 0 and x < 32 and y < 32 then
							for e in self.go.map:entitiesAt(x, y) do
							spawn("rc_pillar_01a_hatless", level, x, y, math.random(0,3), self.go.elevation)
                            break							
							end
						end
					end
				end
				for yy=0,0 do
					for xx=1,1 do
						local x = x + rx * xx + fx * yy
						local y = y + ry * xx + fy * yy
						if x >= 0 and y >= 0 and x < 32 and y < 32 then
							for e in self.go.map:entitiesAt(x, y) do
							spawn("rc_pillar_01b_hatless", level, x, y, math.random(0,3), self.go.elevation)
                            break							
							end
						end
					end
				end
				for yy=0,3 do
					for xx=-1,1 do
						local x = x + rx * xx + fx * yy
						local y = y + ry * xx + fy * yy
						if x >= 0 and y >= 0 and x < 32 and y < 32 then
							for e in self.go.map:entitiesAt(x, y) do
								if e.name == "rc_pillar_01a" 
								or e.name == "rc_pillar_01b" 
								or e.name == "rc_pillar_02a"
								or e.name == "rc_wall_slope"
								or e.name == "rc_ground_pebbles_01" 
								or e.name == "rc_ground_pebbles_02"
								or e.name == "rc_ground_pebbles_03"
								or e.name == "rc_ground_pebbles_04"
								or e.name == "rc_ground_tiles_01"	
								or e.name == "rc_ground_tiles_02" 
								or e.name == "rc_ground_tiles_03"
								or e.name == "rc_ground_tiles_04"
								or e.name == "rc_ground_tiles_05"
								or e.name == "rc_grass_01a"
								or e.name == "rc_grass_01b"
								or e.name == "rc_grass_01c"	
								or e.name == "rc_ceiling_slope"								
								then e:destroy()
								end
							end
						end
					end
				end
			end,
		},
	},
	tags = { "red cave", "vanblam" },
}

defineObject{
	name = "rc_lever",
	components = {
		{
			class = "Model",
			model = "mod_assets/vanblam/red_cave/models/env/rc_lever.fbx",
			staticShadow = true,
		},
		{
			class = "Animation",
			animations = {
				activate = "mod_assets/vanblam/red_cave/animations/rc_lever_down.fbx",
				deactivate = "mod_assets/vanblam/red_cave/animations/rc_lever_up.fbx",
			}
		},
		{
			class = "Clickable",
			offset = vec(0,1.50,0.5),
			size = vec(0.15, 0.9, 0.4),
			maxDistance = 0,
			--debugDraw = true,
		},
		{
			class = "Lever",
			sound = "lever",
		},
	},
	placement = "wall",
	editorIcon = 12,
	tags = { "red cave", "vanblam" },
}

defineObject{
	name = "rc_stone_ground_lever",
	components = {
		{
			class = "Model",
			model = "mod_assets/vanblam/red_cave/models/env/rc_stone_ground_lever.fbx",
			staticShadow = true,
		},
		{
			class = "Animation",
			animations = {
				activate = "mod_assets/vanblam/red_cave/animations/rc_stone_ground_lever_activate.fbx",
				deactivate = "mod_assets/vanblam/red_cave/animations/rc_stone_ground_lever_deactivate.fbx",
			},
			onAnimationEvent = function(self, event)
				if event == "rc_sgl_activate" then
					self.go.lever_hit1:restart()
				elseif event == "rc_sgl_deactivate" then
					self.go.lever_hit2:restart()
				end
			end,
		},
		{
			class = "Clickable",
			offset = vec(0,0.9,-0.7),
			size = vec(1, 0.6, 0.2),
			maxDistance = 0,
			--debugDraw = true,
		},
		{
			class = "Lever",
			sound = "rc_stone_lever",
			enabled = false,
		},
		{
				class = "Particle",
				name = "lever_hit1",
				offset = vec(-0.158,0.54,-0.7),
				particleSystem = "rc_hit_lever",
		},
		{
				class = "Particle",
				name = "lever_hit2",
				offset = vec(0.155,0.54,-0.7),
				particleSystem = "rc_hit_lever",
		},
	},
	placement = "wall",
	editorIcon = 12,
	tags = { "red cave", "vanblam" },
}

defineAnimationEvent{
		animation = "mod_assets/vanblam/red_cave/animations/rc_stone_ground_lever_activate.fbx",
		event = "rc_sgl_activate",
		frame = 19,
}
defineAnimationEvent{
		animation = "mod_assets/vanblam/red_cave/animations/rc_stone_ground_lever_deactivate.fbx",
		event = "rc_sgl_deactivate",
		frame = 19,
}


defineObject{
	name = "rc_button",
	components = {
		{
			class = "Model",
			model = "mod_assets/vanblam/red_cave/models/env/rc_button.fbx",
		},
		{
			class = "Animation",
			animations = {
				press = "mod_assets/vanblam/red_cave/animations/rc_button_press.fbx",
			}
		},
		{
			class = "Clickable",
			offset = vec(0,1.385,0),
			size = vec(0.25, 0.25, 0.25),
			maxDistance = 0,
			--debugDraw = true,
		},
		{
			class = "Button",
			sound = "button",
		},
	},
	placement = "wall",
	editorIcon = 12,
	tags = { "red cave", "vanblam",},
}

defineObject{
	name = "rc_stone_button",
	components = {
		{
			class = "Model",
			model = "mod_assets/vanblam/red_cave/models/env/rc_stone_button.fbx",
		},
		{
			class = "Animation",
			animations = {
				press = "mod_assets/vanblam/red_cave/animations/rc_stone_button_press.fbx",
			}
		},
		{
			class = "Clickable",
			offset = vec(0,1.3,0),
			size = vec(0.35, 0.35, 0.35),
			maxDistance = 0,
			--debugDraw = true,
		},
		{
			class = "Button",
			sound = "rc_stone_button",
		},
	},
	placement = "wall",
	editorIcon = 12,
	tags = { "red cave", "vanblam"},
}

defineObject{
	name = "rc_secret_button",
	components = {
		{
			class = "Model",
			model = "mod_assets/vanblam/red_cave/models/env/rc_secret_button.fbx",
		},
		{
			class = "Animation",
			animations = {
			press = "assets/animations/env/dungeon_secret_button_large_press.fbx",
						
			},
		},
		{
			class = "Clickable",
			offset = vec(-0.38,1.23,0),
			size = vec(0.25, 0.25, 0.25),
			maxDistance = 0,
			--debugDraw = true,
		},
		{
			class = "Button",
			sound = "rc_stone_button",
		},
	},
	placement = "wall",
	editorIcon = 12,
	tags = { "red cave", "vanblam",},
}


defineObject{
	name = "rc_unique_lever",
	baseObject = "base_wall_decoration",
	components = {
		{
			class = "Model",
			model = "mod_assets/vanblam/red_cave/models/env/rc_unique_lever.fbx",
			staticShadow = true,
		},
		{
			class = "Animation",
			animations = {
				activate = "mod_assets/vanblam/red_cave/animations/rc_unique_lever_activate.fbx",
				deactivate = "mod_assets/vanblam/red_cave/animations/rc_unique_lever_rest.fbx",
			},
			onAnimationEvent = function(self, event)
			if event == "rc_unique_activate" then
			self.go.clickable:disable()
				end
			end,
		},
		{
			class = "Clickable",
			offset = vec(0,1.50,0.5),
			size = vec(0.15, 0.9, 0.4),
			maxDistance = 0,
			debugDraw = true,
		},
		{
			class = "Lever",
			sound = "rc_unique_lever",
		},
		{
			class = "Null",
			name = "auto_destroy_objects",
			onInit = function(self)
				local x = self.go.x
				local y = self.go.y
				local facing = self.go.facing
				local level = self.go.level
				
				local fx,fy = getForward(facing)
				local rx,ry = getForward((facing+1)%4)

				do				
					local x = self.go.x + fx
					local y = self.go.y + fy
					if x >= 0 and y >= 0 and x < 32 and y < 32 then
						self.go.map:setAutomapTile(x, y, 4)	-- rocky wall
					end
				end

				-- destroy all pillars ,slopes and supports
				for yy=0,2 do
					for xx=-1,1 do
						local x = x + rx * xx + fx * yy
						local y = y + ry * xx + fy * yy
						if x >= 0 and y >= 0 and x < 32 and y < 32 then
							for e in self.go.map:entitiesAt(x, y) do
								if e.name == "rc_edge_support_01" 
								or e.name == "rc_edge_support_02" 
								or e.name == "rc_edge_support_03"
								or e.name == "rc_edge_support_04"
								or e.name == "rc_edge_support_01b"
								or e.name == "rc_edge_support_02b"
								or e.name == "rc_edge_support_03b"
								or e.name == "rc_edge_support_04b"
								or e.name == "rc_pillar_01a" 
								or e.name == "rc_pillar_01b" 
								or e.name == "rc_pillar_02a"
								or e.name == "rc_wall_slope"
								or e.name == "rc_ceiling_slope"								
								then e:destroy()
								end
							end
						end
					end
				end
			end,
		},
	},
	editorIcon = 92,
	tags = { "red cave", "vanblam" },
}

defineAnimationEvent{
		animation = "mod_assets/vanblam/red_cave/animations/rc_unique_lever_activate.fbx",
		event = "rc_unique_activate",
		frame = 0,
}
	
defineObject{
	name = "rc_puz_pedestal_01",
	baseObject = "base_obstacle",
	components = {
		{
			class = "Model",
			model = "mod_assets/vanblam/red_cave/models/env/rc_puz_pedestal_01.fbx",
			staticShadow = true,
		},
		{
			class = "Animation",
			animations = {
				open = "assets/animations/env/treasure_chest_open.fbx",
				close = "assets/animations/env/treasure_chest_close.fbx",
			},
			onAnimationEvent = function(self, event)
			if event == "open" then
			playSound ("gen_body_motion")
			self.go.controller:open()
			elseif event == "close" then
			playSound ("gen_body_motion")
			self.go.controller:close()
				end
			end,
			--playOnInit = "close",
		},
		{
			class = "Socket",
			name = "socket_top_right",
			offset = vec(-0.23, 0.98, 0.10),
			rotation = vec(-100, 0,0),
			onAcceptItem = function(self,item)
				if GameMode.g1_tempSurface == 1 then
					GameMode.g1_tempSurface = nil
					if self:count() == 0 and item:hasTrait("crystal_key") and not (item:hasTrait("yig_gem") or item:hasTrait("dm_gem")) then
						return true
					end
				end
				return false
			end,
			onInsertItem = function(self,item) self.go.click_tr:disable() end,
			onRemoveItem = function(self,item) if self:isEnabled() and self:count() == 0 and not self.go.click_tr:isEnabled() then self.go.click_tr:enable() else return false end end,
			debugDraw = false,
		},
		{
			class = "Socket",
			name = "socket_top_middle",
			offset = vec(-0.02, 0.98, 0.10),
			rotation = vec(-100, 0,0),
			onAcceptItem = function(self,item)
				if GameMode.g1_tempSurface == 2 then
					GameMode.g1_tempSurface = nil
					if self:count() == 0 and item:hasTrait("crystal_key") and not (item:hasTrait("yig_gem") or item:hasTrait("dm_gem") or item:hasTrait("gem")) then
						return true
					end
				end
				return false
			end,
			onInsertItem = function(self,item) self.go.click_tm:disable() end,
			onRemoveItem = function(self,item) if self:isEnabled() and self:count() == 0 and not self.go.click_tm:isEnabled() then self.go.click_tm:enable() else return false end end,
			debugDraw = false,
		},
		{
			class = "Socket",
			name = "socket_top_left",
			offset = vec(0.21, 0.98, 0.10),
			rotation = vec(-100, 0,0),
			onAcceptItem = function(self,item)
				if GameMode.g1_tempSurface == 3 then
					GameMode.g1_tempSurface = nil
					if self:count() == 0 and item:hasTrait("crystal_key") and not (item:hasTrait("yig_gem") or item:hasTrait("dm_gem") or item:hasTrait("gem")) then
						return true
					end
				end
				return false
			end,
			onInsertItem = function(self,item) self.go.click_tl:disable() end,
			onRemoveItem = function(self,item) if self:isEnabled() and self:count() == 0 and not self.go.click_tl:isEnabled() then self.go.click_tl:enable() else return false end end,
			debugDraw = false,
		},	
		{
			class = "Socket",
			name = "socket_mid_left",
			offset = vec(0.21, 0.88, 0.39),
			rotation = vec(-100, 0,0),
			onAcceptItem = function(self,item)
				if GameMode.g1_tempSurface == 4 then
					GameMode.g1_tempSurface = nil
					if self:count() == 0 and item:hasTrait("crystal_key") and not (item:hasTrait("yig_gem") or item:hasTrait("dm_gem") or item:hasTrait("gem")) then
						return true
					end
				end
				return false
			end,
			onInsertItem = function(self,item) self.go.click_ml:disable() end,
			onRemoveItem = function(self,item) if self:isEnabled() and self:count() == 0 and not self.go.click_ml:isEnabled() then self.go.click_ml:enable() else return false end end,
			debugDraw = false,
		},
{
			class = "Socket",
			name = "socket_mid",
			offset = vec(-0.02, 0.88, 0.39),
			rotation = vec(-100, 0,0),
			onAcceptItem = function(self,item)
				if GameMode.g1_tempSurface == 5 then
					GameMode.g1_tempSurface = nil
					if self:count() == 0 and item:hasTrait("crystal_key") and not (item:hasTrait("yig_gem") or item:hasTrait("dm_gem") or item:hasTrait("gem")) then
						return true
					end
				end
				return false
			end,
			onInsertItem = function(self,item) self.go.click_m:disable() end,
			onRemoveItem = function(self,item) if self:isEnabled() and self:count() == 0 and not self.go.click_m:isEnabled() then self.go.click_m:enable() else return false end end,
			debugDraw = false,
		},						
{
			class = "Socket",
			name = "socket_mid_right",
			offset = vec(-0.23, 0.88, 0.39),
			rotation = vec(-100, 0,0),
			onAcceptItem = function(self,item)
				if GameMode.g1_tempSurface == 6 then
					GameMode.g1_tempSurface = nil
					if self:count() == 0 and item:hasTrait("crystal_key") and not (item:hasTrait("yig_gem") or item:hasTrait("dm_gem") or item:hasTrait("gem")) then
						return true
					end
				end
				return false
			end,
			onInsertItem = function(self,item) self.go.click_mr:disable() end,
			onRemoveItem = function(self,item) if self:isEnabled() and self:count() == 0 and not self.go.click_mr:isEnabled() then self.go.click_mr:enable() else return false end end,
			debugDraw = false,
		},
		{
			class = "Socket",
			name = "socket_bot_left",
			offset = vec(0.21, 0.78, 0.69),
			rotation = vec(-100, 0,0),
			onAcceptItem = function(self,item)
				if GameMode.g1_tempSurface == 7 then
					GameMode.g1_tempSurface = nil
					if self:count() == 0 and item:hasTrait("crystal_key") and not (item:hasTrait("yig_gem") or item:hasTrait("dm_gem") or item:hasTrait("gem")) then
						return true
					end
				end
				return false
			end,
			onInsertItem = function(self,item) self.go.click_bl:disable() end,
			onRemoveItem = function(self,item) if self:isEnabled() and self:count() == 0 and not self.go.click_bl:isEnabled() then self.go.click_bl:enable() else return false end end,
			debugDraw = false,
		},
{
			class = "Socket",
			name = "socket_bot_mid",
			offset = vec(-0.02, 0.78, 0.69),
			rotation = vec(-100, 0,0),
			onAcceptItem = function(self,item)
				if GameMode.g1_tempSurface == 8 then
					GameMode.g1_tempSurface = nil
					if self:count() == 0 and item:hasTrait("crystal_key") and not (item:hasTrait("yig_gem") or item:hasTrait("dm_gem") or item:hasTrait("gem")) then
						return true
					end
				end
				return false
			end,
			onInsertItem = function(self,item) self.go.click_bm:disable() end,
			onRemoveItem = function(self,item) if self:isEnabled() and self:count() == 0 and not self.go.click_bm:isEnabled() then self.go.click_bm:enable() else return false end end,
			debugDraw = false,
		},						
{
			class = "Socket",
			name = "socket_bot_right",
			offset = vec(-0.23, 0.78, 0.69),
			rotation = vec(-100, 0,0),
			onAcceptItem = function(self,item)
				if GameMode.g1_tempSurface == 9 then
					GameMode.g1_tempSurface = nil
					if self:count() == 0 and item:hasTrait("crystal_key") and not (item:hasTrait("yig_gem") or item:hasTrait("dm_gem") or item:hasTrait("gem")) then
						return true
					end
				end
				return false
			end,
			onInsertItem = function(self,item) self.go.click_br:disable() end,
			onRemoveItem = function(self,item) if self:isEnabled() and self:count() == 0 and not self.go.click_br:isEnabled() then self.go.click_br:enable() else return false end end,
			debugDraw = false,
		},
		{
			class = "Clickable",
			name = "click_tr",
			offset = vec(-0.22, 0.98, 0.18),
			size = vec(0.12, 0.12, 0.12),
			maxDistance = 1,
			onClick = function(self)
				if getMouseItem() then GameMode.g1_tempSurface = 1 end
			end,
			--debugDraw = true,
		},
		{
			class = "Clickable",
			name = "click_tm",
			offset = vec(0, 0.98, 0.18),
			size = vec(0.12, 0.12, 0.12),
			maxDistance = 1,
			onClick = function(self)
				if getMouseItem() then GameMode.g1_tempSurface = 2 end
			end,
			--debugDraw = true,
		},
		{
			class = "Clickable",
			name = "click_tl",
			offset = vec(0.22, 0.98, 0.18),
			size = vec(0.12, 0.12, 0.12),
			maxDistance = 1,
			onClick = function(self)
				if getMouseItem() then GameMode.g1_tempSurface = 3 end
			end,
			--debugDraw = true,
		},
		{
			class = "Clickable",
			name = "click_ml",
			offset = vec(0.22, 0.88, 0.47),
			size = vec(0.12, 0.12, 0.12),
			maxDistance = 1,
			onClick = function(self)
				if getMouseItem() then GameMode.g1_tempSurface = 4 end
			end,
			--debugDraw = true,
		},
		{
			class = "Clickable",
			name = "click_m",
			offset = vec(0, 0.88, 0.47),
			size = vec(0.12, 0.12, 0.12),
			maxDistance = 1,
			onClick = function(self)
				if getMouseItem() then GameMode.g1_tempSurface = 5 end
			end,
			--debugDraw = true,
		},
		{
			class = "Clickable",
			name = "click_mr",
			offset = vec(-0.22, 0.88, 0.47),
			size = vec(0.12, 0.12, 0.12),
			maxDistance = 1,
			onClick = function(self)
				if getMouseItem() then GameMode.g1_tempSurface = 6 end
			end,
			--debugDraw = true,
		},
		{
			class = "Clickable",
			name = "click_bl",
			offset = vec(0.22, 0.78, 0.76),
			size = vec(0.12, 0.12, 0.12),
			maxDistance = 1,
			onClick = function(self)
				if getMouseItem() then GameMode.g1_tempSurface = 7 end
			end,
			--debugDraw = true,
		},
		{
			class = "Clickable",
			name = "click_bm",
			offset = vec(0, 0.78, 0.76),
			size = vec(0.12, 0.12, 0.12),
			maxDistance = 1,
			onClick = function(self)
				if getMouseItem() then GameMode.g1_tempSurface = 8 end
			end,
			--debugDraw = true,
		},
		{
			class = "Clickable",
			name = "click_br",
			offset = vec(-0.22, 0.78, 0.76),
			size = vec(0.12, 0.12, 0.12),
			maxDistance = 1,
			onClick = function(self)
				if getMouseItem() then GameMode.g1_tempSurface = 9 end
			end,
			--debugDraw = true,
		},
		{
			class = "Clickable",
			name = "chest_move",
			offset = vec(0,0.4,0.45),
			size = vec(0.9, 0.4, 0.9),
			maxDistance = 1,
			--debugDraw = true,
		},		
		{
			class = "Chest",
		},
		{
			class = "Surface",
			offset = vec(0,1,0),
			size = vec(0,0,0),
			--debugDraw = true,
			onAcceptItem = function(self, item)
				return (item.go.name == "island_map") and self:count() == 0
			end,
			debugDraw = false,
		},
		{
			class = "Controller",
			onOpen = function(self)
				self.go.controller:activate()
			end,
			onClose = function(self)
				self.go.controller:deactivate()
			end,
		},
	},
	editorIcon = 8,
	tags = { "red cave", "vanblam" },
}